/**
 * Temporal Quantified fuzzy DL's
 */


package editor;


import javax.swing.BorderFactory;
import javax.swing.ButtonGroup;
import javax.swing.GroupLayout;
import javax.swing.JButton;
import javax.swing.JCheckBox;
import javax.swing.JComboBox;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JOptionPane;
import javax.swing.JPanel;
import javax.swing.JDialog;
import javax.swing.DefaultComboBoxModel;
import javax.swing.LayoutStyle;
import javax.swing.SwingConstants;
import javax.swing.border.BevelBorder;

import reasoner.*;

import java.awt.Color;
import java.util.Set;
import java.util.Iterator;

/**
 * A javax.swing.JDialog for Query editing
 *
 * @version 1.0 10/12/07
 * @author  marco furlan
 */
public class QueryDialog extends JDialog {
        private EditorFrame ef;  

        /**
         *  Creates new ConceptDialog
         * @param parent the parent
         * @param title the title
         * @param modal the modal
         */
        public QueryDialog(JFrame parent, String title, boolean modal) {
            super(parent, title, modal);
            this.ef = (EditorFrame)parent;
            this.kb = ef.getKb();
            initComponents();
        }
        
    
    /** This method is called from within the constructor to
     * initialize the form.     
     */      
    private void initComponents() {
       
        jPanel1 = new JPanel();
        jLabel1 = new JLabel();
        okBtn = new JButton();
        jLabel3 = new JLabel();
        createBtn = new JButton();
        closeBtn = new JButton();
        jLabel4 = new JLabel();
        jLabel12 = new JLabel();
        jCheckBox1 = new JCheckBox();
        jCheckBox2 = new JCheckBox();
        jLabel5 = new JLabel();
        concComboBox1 = new JComboBox();
        jLabel2 = new JLabel();
        quantComboBox = new JComboBox();
        jLabel6 = new JLabel();
        roleComboBox = new JComboBox();
        jLabel7 = new JLabel();
        concComboBox2 = new JComboBox();
        jLabel8 = new JLabel();
        jLabel9 = new JLabel();
        jLabel10 = new JLabel();
        jLabel11 = new JLabel();
        jLabel13 = new JLabel();
        jLabel14 = new JLabel();
        concComboBox3 = new JComboBox();
        jLabel15 = new JLabel();
        jLabel16 = new JLabel();
        opComboBox = new JComboBox();
        jLabel17 = new JLabel();
        quantComboBox1 = new JComboBox();
        jLabel18 = new JLabel();
        jLabel19 = new JLabel();
        tquantLabel = new JLabel();
        tquantComboBox = new JComboBox();
        tqLabel = new JLabel();

        addWindowListener(new java.awt.event.WindowAdapter() {
            public void windowClosing(java.awt.event.WindowEvent evt) {
                closeDialog(evt);
            }
        });

        jPanel1.setBackground(new java.awt.Color(219, 229, 241));
//        jPanel1.setBorder(javax.swing.BorderFactory.createMatteBorder(2, 2, 2, 2, new java.awt.Color(51, 255, 51)));
        jPanel1.setBorder(javax.swing.BorderFactory.createBevelBorder(BevelBorder.RAISED, new java.awt.Color(51, 255, 51), Color.darkGray));
    	
        jLabel1.setFont(new java.awt.Font("Tahoma", 0, 18));
        jLabel1.setForeground(new java.awt.Color(0, 153, 0));
        jLabel1.setHorizontalAlignment(SwingConstants.CENTER);
        jLabel1.setText("QUERY EDITOR");
        jLabel1.setHorizontalTextPosition(SwingConstants.CENTER);

        okBtn.setText("OK");
        okBtn.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                okBtnActionPerformed(evt);
            }
        });

        jLabel3.setFont(new java.awt.Font("Tahoma", 0, 18));
        jLabel3.setForeground(new java.awt.Color(255, 51, 51));
        jLabel3.setHorizontalAlignment(SwingConstants.LEFT);
        jLabel3.setText("QUERY as a new Concept, from already existing components:             ");

        createBtn.setText("Create Query");
        createBtn.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                createButtonActionPerformed(evt);
            }
        });

        closeBtn.setText("CLOSE");
        closeBtn.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                closeBtnActionPerformed(evt);
            }
        });

        jLabel4.setFont(new java.awt.Font("Tahoma", 0, 18));
        jLabel4.setForeground(new java.awt.Color(255, 51, 51));
        jLabel4.setHorizontalAlignment(SwingConstants.LEFT);
        jLabel4.setText("from a role and a Concept, like: (TempQuantifier)(Quantifier)role.Concept");

        jLabel12.setFont(new java.awt.Font("Tahoma", 0, 18));
        jLabel12.setForeground(new java.awt.Color(255, 51, 51));
        jLabel12.setHorizontalAlignment(SwingConstants.LEFT);
        jLabel12.setText("from two Concept, like (Quantifier)Concept1.Operator.Concept2");

        jCheckBox1.setBorder(BorderFactory.createEmptyBorder(0, 0, 0, 0));
        jCheckBox1.setMargin(new java.awt.Insets(0, 0, 0, 0));
        jCheckBox1.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jCheckBox1ActionPerformed(evt);
            }
        });

        jCheckBox2.setSelected(true);
        jCheckBox2.setBorder(BorderFactory.createEmptyBorder(0, 0, 0, 0));
        jCheckBox2.setMargin(new java.awt.Insets(0, 0, 0, 0));
        jCheckBox1.setSelected(false);
        setComponent(true);
        jCheckBox2.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jCheckBox2ActionPerformed(evt);
            }
        });

        jLabel5.setText("Concept:");

        concComboBox1.setModel(new DefaultComboBoxModel(new String[] { "...       " }));
        keys = kb.getConcrConcepts().keySet();
        if (!keys.isEmpty()){
            Iterator<String> it = keys.iterator();
            concComboBox1.removeAllItems();
            concComboBox1.addItem("...   ");
            while(it.hasNext()){
                String s = (String)it.next();
                concComboBox1.addItem(s);
            }
        }

        concComboBox1.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                concComboBox1ActionPerformed(evt);
            }
        });

        jLabel2.setText("Quantifier: ");

        quantComboBox.setModel(new DefaultComboBoxModel(new String[] { "...       " }));
        keys = kb.getQuantifiers().keySet();
        if (!keys.isEmpty()){
            Iterator<String> it = keys.iterator();
            quantComboBox.removeAllItems();
            quantComboBox.addItem("...   ");
            while(it.hasNext()){
                String s = (String)it.next();
                quantComboBox.addItem(s);
            }
        }
        quantComboBox.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                quantComboBoxActionPerformed(evt);
            }
        });

        jLabel6.setText("Role: ");

        roleComboBox.setModel(new DefaultComboBoxModel(new String[] { "...       " }));
        keys = kb.getRoles().keySet();
        if (!keys.isEmpty()){
            Iterator<String> it = keys.iterator();
            roleComboBox.removeAllItems();
            while(it.hasNext()){
                String s = (String)it.next();
                roleComboBox.addItem(s);
            }
        }
        roleComboBox.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                roleComboBoxActionPerformed(evt);
            }
        });

        jLabel7.setText("Concept: ");

        concComboBox2.setModel(new DefaultComboBoxModel(new String[] { "...       " }));
        keys = kb.getConcrConcepts().keySet();
        if (!keys.isEmpty()){
            Iterator<String> it = keys.iterator();
            concComboBox2.removeAllItems();
            while(it.hasNext()){
                String s = (String)it.next();
                concComboBox2.addItem(s);
            }
        }
        concComboBox2.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                concComboBox2ActionPerformed(evt);
            }
        });

        jLabel8.setText("Query:  ....................................");

        jLabel9.setText("jLabel9");
        jLabel9.setText(quantComboBox.getSelectedItem().toString());

        jLabel10.setText("jLabel10");
        jLabel10.setText(roleComboBox.getSelectedItem().toString());

        jLabel11.setText("jLabel11");
        jLabel11.setText(concComboBox2.getSelectedItem().toString());

        jLabel13.setText("jLabel13");
        jLabel13.setText(concComboBox1.getSelectedItem().toString());

        jLabel14.setText("Concept:");

        concComboBox3.setModel(new DefaultComboBoxModel(new String[] { "...       " }));
        keys = kb.getConcrConcepts().keySet();
        if (!keys.isEmpty()){
            Iterator<String> it = keys.iterator();
            concComboBox3.removeAllItems();
            while(it.hasNext()){
                String s = (String)it.next();
                concComboBox3.addItem(s);
            }
        }

        concComboBox3.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                concComboBox3ActionPerformed(evt);
            }
        });

        jLabel15.setText("jLabel15");
        jLabel15.setText(concComboBox3.getSelectedItem().toString());

        jLabel16.setText("Operator: ");

        opComboBox.setModel(new DefaultComboBoxModel(new String[] { "Until", "Since", "Union", "Intersection", "SubsumedNext", "SubsNext" }));
        opComboBox.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                opComboBoxActionPerformed(evt);                
            }
        });

        jLabel17.setText("jLabel17");
        jLabel17.setText(opComboBox.getSelectedItem().toString());

        quantComboBox1.setModel(new DefaultComboBoxModel(new String[] { "...       " }));
        keys = kb.getQuantifiers().keySet();
        if (!keys.isEmpty()){
            Iterator<String> it = keys.iterator();
            quantComboBox1.removeAllItems();
            while(it.hasNext()){
                String s = (String)it.next();
                quantComboBox1.addItem(s);
            }
        }
        quantComboBox1.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                quantComboBox1ActionPerformed(evt);
            }
        });

        jLabel18.setText("Quantifier: ");

        jLabel19.setText("jLabel19");
        jLabel19.setText(quantComboBox1.getSelectedItem().toString());

        tquantLabel.setText("TempQuantifier: ");

        tquantComboBox.setModel(new DefaultComboBoxModel(new String[] { "...       " }));
        keys = kb.getQuantifiers().keySet();
        if (!keys.isEmpty()){
            Iterator<String> it = keys.iterator();
            tquantComboBox.removeAllItems();
            tquantComboBox.addItem("...   ");
            while(it.hasNext()){
                String s = (String)it.next();
                tquantComboBox.addItem(s);
            }
        }
        tquantComboBox.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                tquantComboBoxActionPerformed(evt);
            }
        });

        tqLabel.setText("tqlabel");
        tqLabel.setText(tquantComboBox.getSelectedItem().toString());

        GroupLayout jPanel1Layout = new GroupLayout(jPanel1);
        jPanel1.setLayout(jPanel1Layout);
        jPanel1Layout.setHorizontalGroup(
            jPanel1Layout.createParallelGroup(GroupLayout.Alignment.LEADING)
            .addGroup(jPanel1Layout.createSequentialGroup()
                .addGroup(jPanel1Layout.createParallelGroup(GroupLayout.Alignment.LEADING)
                    .addGroup(jPanel1Layout.createSequentialGroup()
                        .addGap(238, 238, 238)
                        .addComponent(jLabel1))
                    .addGroup(jPanel1Layout.createSequentialGroup()
                        .addGap(504, 504, 504)
                        .addComponent(closeBtn))
                    .addGroup(jPanel1Layout.createSequentialGroup()
                        .addGroup(jPanel1Layout.createParallelGroup(GroupLayout.Alignment.LEADING)
                            .addGroup(jPanel1Layout.createSequentialGroup()
                                .addGroup(jPanel1Layout.createParallelGroup(GroupLayout.Alignment.LEADING)
                                    .addGroup(jPanel1Layout.createSequentialGroup()
                                        .addGap(110, 110, 110)
                                        .addComponent(jLabel18)
                                        .addGap(14, 14, 14)
                                        .addGroup(jPanel1Layout.createParallelGroup(GroupLayout.Alignment.LEADING)
                                            .addComponent(quantComboBox1, GroupLayout.PREFERRED_SIZE, 98, GroupLayout.PREFERRED_SIZE)
                                            .addComponent(jLabel19)))
                                    .addGroup(GroupLayout.Alignment.TRAILING, jPanel1Layout.createSequentialGroup()
                                        .addGroup(jPanel1Layout.createParallelGroup(GroupLayout.Alignment.LEADING)
                                            .addComponent(tqLabel)
                                            .addComponent(tquantComboBox, GroupLayout.PREFERRED_SIZE, 98, GroupLayout.PREFERRED_SIZE))
                                        .addPreferredGap(LayoutStyle.ComponentPlacement.RELATED)))
                                .addGap(58, 58, 58)
                                .addGroup(jPanel1Layout.createParallelGroup(GroupLayout.Alignment.LEADING)
                                    .addGroup(GroupLayout.Alignment.TRAILING, jPanel1Layout.createSequentialGroup()
                                        .addComponent(jLabel5)
                                        .addGap(26, 26, 26)
                                        .addGroup(jPanel1Layout.createParallelGroup(GroupLayout.Alignment.LEADING)
                                            .addGroup(jPanel1Layout.createSequentialGroup()
                                                .addComponent(concComboBox1, GroupLayout.PREFERRED_SIZE, 98, GroupLayout.PREFERRED_SIZE)
                                                .addGap(35, 35, 35)
                                                .addComponent(jLabel16))
                                            .addComponent(jLabel13))
                                        .addPreferredGap(LayoutStyle.ComponentPlacement.RELATED))
                                    .addGroup(GroupLayout.Alignment.TRAILING, jPanel1Layout.createSequentialGroup()
                                        .addComponent(jLabel2)
                                        .addGap(20, 20, 20)
                                        .addGroup(jPanel1Layout.createParallelGroup(GroupLayout.Alignment.LEADING)
                                            .addComponent(jLabel9)
                                            .addGroup(jPanel1Layout.createSequentialGroup()
                                                .addComponent(quantComboBox, GroupLayout.PREFERRED_SIZE, 98, GroupLayout.PREFERRED_SIZE)
                                                .addGap(47, 47, 47)
                                                .addComponent(jLabel6)))
                                        .addGap(17, 17, 17))))
                            .addGroup(jPanel1Layout.createSequentialGroup()
                                .addGap(39, 39, 39)
                                .addGroup(jPanel1Layout.createParallelGroup(GroupLayout.Alignment.LEADING)
                                    .addComponent(jLabel3)
                                    .addGroup(jPanel1Layout.createSequentialGroup()
                                        .addGroup(jPanel1Layout.createParallelGroup(GroupLayout.Alignment.LEADING)
                                            .addComponent(jCheckBox2)
                                            .addComponent(jCheckBox1))
                                        .addGap(27, 27, 27)
                                        .addGroup(jPanel1Layout.createParallelGroup(GroupLayout.Alignment.LEADING)
                                            .addComponent(jLabel12)
                                            .addComponent(jLabel4)
                                            .addComponent(tquantLabel)))
                                    .addComponent(jLabel8)
                                    .addGroup(jPanel1Layout.createSequentialGroup()
                                        .addComponent(okBtn)
                                        .addGap(64, 64, 64)
                                        .addComponent(createBtn)))))
                        .addPreferredGap(LayoutStyle.ComponentPlacement.RELATED)
                        .addGroup(jPanel1Layout.createParallelGroup(GroupLayout.Alignment.LEADING)
                            .addComponent(jLabel10)
                            .addComponent(jLabel17)
                            .addGroup(jPanel1Layout.createParallelGroup(GroupLayout.Alignment.TRAILING, false)
                                .addGroup(jPanel1Layout.createSequentialGroup()
                                    .addComponent(opComboBox, GroupLayout.PREFERRED_SIZE, GroupLayout.DEFAULT_SIZE, GroupLayout.PREFERRED_SIZE)
                                    .addGap(17, 17, 17)
                                    .addComponent(jLabel14))
                                .addGroup(GroupLayout.Alignment.LEADING, jPanel1Layout.createSequentialGroup()
                                    .addComponent(roleComboBox, GroupLayout.PREFERRED_SIZE, 98, GroupLayout.PREFERRED_SIZE)
                                    .addPreferredGap(LayoutStyle.ComponentPlacement.RELATED, GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                                    .addComponent(jLabel7))))
                        .addPreferredGap(LayoutStyle.ComponentPlacement.RELATED)
                        .addGroup(jPanel1Layout.createParallelGroup(GroupLayout.Alignment.LEADING)
                            .addComponent(jLabel11)
                            .addGroup(jPanel1Layout.createParallelGroup(GroupLayout.Alignment.TRAILING)
                                .addComponent(concComboBox3, GroupLayout.PREFERRED_SIZE, 98, GroupLayout.PREFERRED_SIZE)
                                .addComponent(concComboBox2, GroupLayout.PREFERRED_SIZE, 98, GroupLayout.PREFERRED_SIZE)
                                .addComponent(jLabel15, GroupLayout.Alignment.LEADING)))))
                .addContainerGap(29, Short.MAX_VALUE))
        );
        jPanel1Layout.setVerticalGroup(
            jPanel1Layout.createParallelGroup(GroupLayout.Alignment.LEADING)
            .addGroup(jPanel1Layout.createSequentialGroup()
                .addGap(29, 29, 29)
                .addComponent(jLabel1, GroupLayout.PREFERRED_SIZE, 26, GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(jLabel3, GroupLayout.PREFERRED_SIZE, 26, GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(jPanel1Layout.createParallelGroup(GroupLayout.Alignment.TRAILING)
                    .addComponent(jCheckBox1)
                    .addComponent(jLabel12, GroupLayout.PREFERRED_SIZE, 26, GroupLayout.PREFERRED_SIZE))
                .addPreferredGap(LayoutStyle.ComponentPlacement.RELATED, 26, Short.MAX_VALUE)
                .addGroup(jPanel1Layout.createParallelGroup(GroupLayout.Alignment.BASELINE)
                    .addComponent(jLabel14)
                    .addComponent(concComboBox3, GroupLayout.PREFERRED_SIZE, GroupLayout.DEFAULT_SIZE, GroupLayout.PREFERRED_SIZE)
                    .addComponent(opComboBox, GroupLayout.PREFERRED_SIZE, GroupLayout.DEFAULT_SIZE, GroupLayout.PREFERRED_SIZE)
                    .addComponent(jLabel16)
                    .addComponent(jLabel18)
                    .addComponent(quantComboBox1, GroupLayout.PREFERRED_SIZE, GroupLayout.DEFAULT_SIZE, GroupLayout.PREFERRED_SIZE)
                    .addComponent(concComboBox1, GroupLayout.PREFERRED_SIZE, GroupLayout.DEFAULT_SIZE, GroupLayout.PREFERRED_SIZE)
                    .addComponent(jLabel5))
                .addPreferredGap(LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(jPanel1Layout.createParallelGroup(GroupLayout.Alignment.BASELINE)
                    .addComponent(jLabel17)
                    .addComponent(jLabel19)
                    .addComponent(jLabel13)
                    .addComponent(jLabel15))
                .addGap(15, 15, 15)
                .addGroup(jPanel1Layout.createParallelGroup(GroupLayout.Alignment.TRAILING)
                    .addComponent(jLabel4, GroupLayout.PREFERRED_SIZE, 26, GroupLayout.PREFERRED_SIZE)
                    .addComponent(jCheckBox2))
                .addGap(32, 32, 32)
                .addGroup(jPanel1Layout.createParallelGroup(GroupLayout.Alignment.BASELINE)
                    .addComponent(concComboBox2, GroupLayout.PREFERRED_SIZE, GroupLayout.DEFAULT_SIZE, GroupLayout.PREFERRED_SIZE)
                    .addComponent(jLabel7)
                    .addComponent(roleComboBox, GroupLayout.PREFERRED_SIZE, GroupLayout.DEFAULT_SIZE, GroupLayout.PREFERRED_SIZE)
                    .addComponent(jLabel6)
                    .addComponent(quantComboBox, GroupLayout.PREFERRED_SIZE, GroupLayout.DEFAULT_SIZE, GroupLayout.PREFERRED_SIZE)
                    .addComponent(jLabel2)
                    .addComponent(tquantComboBox, GroupLayout.PREFERRED_SIZE, GroupLayout.DEFAULT_SIZE, GroupLayout.PREFERRED_SIZE)
                    .addComponent(tquantLabel))
                .addGroup(jPanel1Layout.createParallelGroup(GroupLayout.Alignment.LEADING)
                    .addGroup(jPanel1Layout.createSequentialGroup()
                        .addGap(62, 62, 62)
                        .addComponent(jLabel8)
                        .addGap(48, 48, 48)
                        .addGroup(jPanel1Layout.createParallelGroup(GroupLayout.Alignment.BASELINE)
                            .addComponent(okBtn)
                            .addComponent(createBtn)
                            .addComponent(closeBtn)))
                    .addGroup(jPanel1Layout.createSequentialGroup()
                        .addPreferredGap(LayoutStyle.ComponentPlacement.RELATED)
                        .addGroup(jPanel1Layout.createParallelGroup(GroupLayout.Alignment.BASELINE)
                            .addComponent(jLabel11)
                            .addComponent(jLabel10)
                            .addComponent(jLabel9)
                            .addComponent(tqLabel))))
                .addGap(79, 79, 79))
        );
        getContentPane().add(jPanel1, java.awt.BorderLayout.CENTER);

        pack();
    }

    /**
     * Invoked when an action is performed on closeBtn
     * @param evt the event
     */
    private void closeBtnActionPerformed(java.awt.event.ActionEvent evt) {
        closeDialog();
    }
/**
 * closes this QueryDialog
 */
private void closeDialog(){
        setVisible(false);
        ef.showKb();
        dispose();
    }

    /**
     * Invoked when an action is performed on tquantComboBox
     * @param evt the event
     */
    private void tquantComboBoxActionPerformed(java.awt.event.ActionEvent evt) {
        tqLabel.setText(tquantComboBox.getSelectedItem().toString());
    }

    /**
     * Invoked when an action is performed on quantComboBox
     * @param evt the event
     */
    private void quantComboBox1ActionPerformed(java.awt.event.ActionEvent evt) {
        jLabel19.setText(quantComboBox1.getSelectedItem().toString());
    }

    /**
     * Invoked when an action is performed on opComboBox
     * @param evt the event
     */
    private void opComboBoxActionPerformed(java.awt.event.ActionEvent evt) {
        String op = opComboBox.getSelectedItem().toString();
        if (op.equalsIgnoreCase("subsNext")){
            concComboBox1.setSelectedItem("...   ");
        }
        jLabel17.setText(opComboBox.getSelectedItem().toString());
    }

    /**
     * Invoked when an action is performed on concComboBox
     * @param evt the event
     */
    private void concComboBox3ActionPerformed(java.awt.event.ActionEvent evt) {
        jLabel15.setText(concComboBox3.getSelectedItem().toString());
    }

    /**
     * Invoked when an action is performed on jCheckBox
     * @param evt the event
     */
    private void jCheckBox2ActionPerformed(java.awt.event.ActionEvent evt) {
         if (jCheckBox2.isSelected()){
            jCheckBox1.setSelected(false);   
            setComponent(true);
        }else {
             jCheckBox1.setSelected(true); 
            setComponent(false);
        }
    }
    
    /**
     * sets the Components
     * @param roleQuery indicates wether Query is RoleQuery
     */
    public void setComponent (boolean roleQuery){
         jLabel2.setEnabled(roleQuery);
             jLabel6.setEnabled(roleQuery);
              jLabel7.setEnabled(roleQuery);
               jLabel9.setEnabled(roleQuery);
                jLabel10.setEnabled(roleQuery);
                 jLabel11.setEnabled(roleQuery);
                 tquantComboBox.setEnabled(roleQuery);
                 tqLabel.setEnabled(roleQuery);
                 tquantLabel.setEnabled(roleQuery);
                 quantComboBox.setEnabled(roleQuery);
                  roleComboBox.setEnabled(roleQuery);
                   concComboBox2.setEnabled(roleQuery);
                    jLabel2.setEnabled(roleQuery);
             jLabel5.setEnabled(!roleQuery);
              jLabel16.setEnabled(!roleQuery);
               jLabel14.setEnabled(!roleQuery);
                jLabel13.setEnabled(!roleQuery);
                 jLabel17.setEnabled(!roleQuery);
                  jLabel15.setEnabled(!roleQuery);
                   jLabel18.setEnabled(!roleQuery);
                    jLabel19.setEnabled(!roleQuery);
                quantComboBox1.setEnabled(!roleQuery);
                 concComboBox1.setEnabled(!roleQuery);
                  opComboBox.setEnabled(!roleQuery);
                   concComboBox3.setEnabled(!roleQuery);
    }
    
    /**
     * Invoked when an action is performed on jCheckBox1
     * @param evt the event
     */
    private void jCheckBox1ActionPerformed(java.awt.event.ActionEvent evt) {
        if (jCheckBox1.isSelected()){
            jCheckBox2.setSelected(false); 
            setComponent(false);
        }else{
            jCheckBox2.setSelected(true); 
            setComponent(true);
        }
        
    }

    /**
     * Invoked when an action is performed on concComboBox1
     * @param evt the event
     */
    private void concComboBox1ActionPerformed(java.awt.event.ActionEvent evt) {
        if (opComboBox.getSelectedItem().toString().equalsIgnoreCase("subsNext"))
            concComboBox1.setSelectedItem("...   ");
        jLabel13.setText(concComboBox1.getSelectedItem().toString());
    }

    /**
     * Invoked when an action is performed on concComboBox2
     * @param evt the event
     */
    private void concComboBox2ActionPerformed(java.awt.event.ActionEvent evt) {
        //
        jLabel11.setText(concComboBox2.getSelectedItem().toString());
    }

    /**
     * Invoked when an action is performed on roleComboBox
     * @param evt the event
     */
    private void roleComboBoxActionPerformed(java.awt.event.ActionEvent evt) {
       
        jLabel10.setText(roleComboBox.getSelectedItem().toString());
    }

    /**
     * Invoked when an action is performed on quantComboBox
     * @param evt the event
     */
    private void quantComboBoxActionPerformed(java.awt.event.ActionEvent evt) {
       jLabel9.setText(quantComboBox.getSelectedItem().toString());
    }


    /**
     * Invoked when an action is performed on okBtn
     * @param evt the event
     */
    private void okBtnActionPerformed(java.awt.event.ActionEvent evt) {
        closeDialog();       
    }

    /**
     * Invoked when an action is performed on createbtn: creates a new Query
     * @param evt the event
     */
    private void createButtonActionPerformed(java.awt.event.ActionEvent evt) {
//        String qt,q,r,c,op,c2;
//        if (new QueryVerifier(this).verify()){
//        if (jCheckBox1.isSelected()){   //OpQuery            
//            c = concComboBox1.getSelectedItem().toString();
//            c2 = concComboBox3.getSelectedItem().toString();
//            op = opComboBox.getSelectedItem().toString();
//            if (op.equals("SubsNext")){
//                 c = c2;
//            }                      
//            qry = new OpQuery ((ConcreteConcept)kb.getConcrConcepts().get(c),
//                    op,
//                    (ConcreteConcept)kb.getConcrConcepts().get(c2),
//                    kb);
//            q = quantComboBox.getSelectedItem().toString().trim();
//            if (!q.equals("..."))
//                ((OpQuery)qry).setQ((Quantifier)kb.getQuantifiers().get(q));
//            JOptionPane.showMessageDialog(null ,
//                      qry.toString(),"QUERY",JOptionPane.INFORMATION_MESSAGE); 
//        }else if(jCheckBox2.isSelected()){  //RoleQuery
//            qt = tquantComboBox.getSelectedItem().toString();
//            q = quantComboBox.getSelectedItem().toString();
//            r = roleComboBox.getSelectedItem().toString();
//            c = concComboBox2.getSelectedItem().toString();
//            qry = new RoleQuery ((Quantifier)kb.getQuantifiers().get(qt),
//                    (Quantifier)kb.getQuantifiers().get(q),
//                    (Role)kb.getRoles().get(r),
//                    (ConcreteConcept)kb.getConcrConcepts().get(c),
//                    kb);
//              JOptionPane.showMessageDialog(null ,
//                      qry.toString(),"QUERY",JOptionPane.INFORMATION_MESSAGE); 
//        }
//        jLabel8.setText(qry.toString());
//        }
        String qt,q,r,c,op,c2;
        qtifier = null;
        qtifier1 = null;
        if (new QueryVerifier(this).verify()){
        if (jCheckBox1.isSelected()){   //OpQuery            
            c = concComboBox1.getSelectedItem().toString();
            c2 = concComboBox3.getSelectedItem().toString();
            op = opComboBox.getSelectedItem().toString();
            if (op.equals("SubsNext")){
                 c = c2;
            }                      
            qry = new OpQuery ((ConcreteConcept)kb.getConcrConcepts().get(c),
                    op,
                    (ConcreteConcept)kb.getConcrConcepts().get(c2),
                    kb);
            q = quantComboBox1.getSelectedItem().toString().trim();
            if (!q.equals("..."))
                ((OpQuery)qry).setQ((Quantifier)kb.getQuantifiers().get(q));
            javax.swing.JOptionPane.showMessageDialog(null ,
                      qry.toString(),"QUERY",javax.swing.JOptionPane.INFORMATION_MESSAGE); 
        }else if(jCheckBox2.isSelected()){  //RoleQuery
            qt = tquantComboBox.getSelectedItem().toString().trim();
            q = quantComboBox.getSelectedItem().toString().trim();
            if (qt.equals("..."))
                qtifier1 = null;
            else qtifier1 = (Quantifier)kb.getQuantifiers().get(qt);
            if (q.equals("..."))
                qtifier = null;
            else qtifier = (Quantifier)kb.getQuantifiers().get(q);
            r = roleComboBox.getSelectedItem().toString();
            c = concComboBox2.getSelectedItem().toString();
            qry = new RoleQuery (qtifier1,
                    qtifier,
                    (Role)kb.getRoles().get(r),
                    (ConcreteConcept)kb.getConcrConcepts().get(c),
                    kb);
              javax.swing.JOptionPane.showMessageDialog(null ,
                      qry.toString(),"QUERY",javax.swing.JOptionPane.INFORMATION_MESSAGE); 
        }
        jLabel8.setText(qry.toString());
        }
    }
    
    /**
     * Closes this QueryDialog
     * @param evt the event
     */
    private void closeDialog(java.awt.event.WindowEvent evt) {
        setVisible(false);
        ef.showKb();
        dispose();
    }
    
    /**
     * the main method
     * @param args the command line arguments
     */
    public static void main(String args[]) {
        java.awt.EventQueue.invokeLater(new Runnable() {
            public void run() {
                String title = "Query Editor";
                new QueryDialog(new EditorFrame(), title, true).setVisible(true);                
            }
        });
    }
    
    
    // Variables declaration 
    protected JButton closeBtn;
    protected JComboBox concComboBox1;
    protected JComboBox concComboBox2;
    protected JComboBox concComboBox3;
    protected JButton okBtn;
    protected JButton createBtn;
    protected JCheckBox jCheckBox1;
    protected JCheckBox jCheckBox2;
    protected JLabel jLabel1;
    protected JLabel jLabel10;
    protected JLabel jLabel11;
    protected JLabel jLabel12;
    protected JLabel jLabel13;
    protected JLabel jLabel14;
    protected JLabel jLabel15;
    protected JLabel jLabel16;
    protected JLabel jLabel17;
    protected JLabel jLabel18;
    protected JLabel jLabel19;
    protected JLabel jLabel2;
    protected JLabel jLabel3;
    protected JLabel jLabel4;
    protected JLabel jLabel5;
    protected JLabel jLabel6;
    protected JLabel jLabel7;
    protected JLabel jLabel8;
    protected JLabel jLabel9;
    private JPanel jPanel1;
    protected JComboBox opComboBox;
    protected JComboBox quantComboBox;
    protected JComboBox quantComboBox1;
    protected JComboBox roleComboBox;
    protected JLabel tqLabel;
    protected JComboBox tquantComboBox;
    protected JLabel tquantLabel;
    protected KnowledgeBase kb;
    protected Query qry;
    protected Quantifier qtifier, qtifier1;
    private Set keys;
}
