/**
 * Temporal Quantified fuzzy DL's
 */

package monitor;

import java.awt.Color;
import java.awt.Dimension;
import java.awt.Font;
import java.awt.event.KeyEvent;
import java.io.File;
import java.io.FileNotFoundException;
import javax.swing.GroupLayout;
import javax.swing.JButton;
import javax.swing.JLabel;
import javax.swing.JMenu;
import javax.swing.JMenuBar;
import javax.swing.JMenuItem;
import javax.swing.JPopupMenu;
import javax.swing.JScrollPane;
import javax.swing.JTextArea;
import javax.swing.LayoutStyle;
import javax.swing.JFileChooser;
import javax.xml.bind.JAXBException;
import util.XmlFileFilter;

import javax.swing.border.BevelBorder;
import javax.swing.border.Border;
import javax.swing.BorderFactory;

/**
 * A JFrame as a Graphical User Interface for Monitor
 * 
 * @version 1.0 10/12/07
 * @author  marco furlan
 */
public class MonitorJFrame extends javax.swing.JFrame {
	private Monitor monitor;
	private File loadFile= null;
	private File stateFile= null;
	/**
	 * The start button
	 */
	JButton startButton;
	JButton crispStartBtn;
	/**
	 * The stop button
	 */
	JButton stopButton;
	/**
	 * The load button
	 */
	JButton loadBtn;
	/**
	 * The current state button
	 */
	JButton stateFindBtn;
	JLabel jLabel1;
	JLabel jLabel2;
	JLabel jLabel3;
	JLabel jLabel4;
	JLabel jLabel5;
	javax.swing.JPanel jPanel1;
	JScrollPane jScrollPane1;
	JScrollPane jScrollPane2;
	JScrollPane jScrollPane3;
	/**
	 * The MTBox textArea
	 */
	JTextArea jTextArea1;
	/**
	 * The current state textArea
	 */
	JTextArea jTextArea2;
	/**
	 * The evaluation textArea
	 */
	JTextArea jTextArea3;

	JMenu monitorMenu;
	JMenuBar menuBar;
	JPopupMenu monitorPopupMenu;
	JMenuItem pray;
	Dimension d = new Dimension(85, 25); 
	Border
	brd = BorderFactory.createMatteBorder
	(1, 1, 2, 2, Color.black),
	brd1 = BorderFactory.createMatteBorder
	(1, 1, 2, 0, Color.black);


	/**
	 * Creates new MonitorJFrame
	 */
	public MonitorJFrame() {
		initComponents();
	}
	/**
	 *  Creates new MonitorJFrame
	 * @param m the Monitor
	 */
	public MonitorJFrame(Monitor m) {

		initComponents();
		this.monitor = m;
	}


	/**
	 * Initializes the Components
	 */
	private void initComponents() {


		jPanel1 = new javax.swing.JPanel();
		jScrollPane1 = new JScrollPane();
		jTextArea1 = new JTextArea();
		jScrollPane2 = new JScrollPane();
		jTextArea2 = new JTextArea();
		jLabel1 = new JLabel();
		jLabel2 = new JLabel();
		startButton = new JButton();
		crispStartBtn = new JButton();
		stopButton = new JButton();
		loadBtn = new JButton();
		stateFindBtn = new JButton();
		jLabel3 = new JLabel();
		jScrollPane3 = new JScrollPane();
		jTextArea3 = new JTextArea();
		jLabel4 = new JLabel();
		jLabel5 = new JLabel();        


		setDefaultCloseOperation(javax.swing.WindowConstants.DISPOSE_ON_CLOSE);
		setTitle("PRAY - PREDATOR MONITOR");
//		jPanel1.setBorder(javax.swing.BorderFactory.createMatteBorder(2, 2, 2, 2, new java.awt.Color(51, 255, 51)));
	      jPanel1.setBorder(javax.swing.BorderFactory.createBevelBorder(BevelBorder.RAISED, new java.awt.Color(51, 255, 51), Color.darkGray));
	  	
		jPanel1.setBackground(new Color(219,229,241));
		jTextArea1.setColumns(16);
		jTextArea1.setRows(5);
		jTextArea1.setFont(new Font("Tahoma", 0, 15));
		jScrollPane1.setViewportView(jTextArea1);

		jTextArea2.setColumns(16);
		jTextArea2.setRows(5);
		jTextArea2.setFont(new Font("Tahoma", 0, 15));
		jTextArea2.setToolTipText("current state");
		jScrollPane2.setViewportView(jTextArea2);

		jLabel1.setText("MT - Box: ");
		jLabel2.setText("current state:");

		startButton.setText("start");
		startButton.addMouseListener(new java.awt.event.MouseAdapter() {
			public void mouseClicked(java.awt.event.MouseEvent evt) {
				startButtonMouseClicked(evt);
			}
		});
		startButton.setEnabled(false);

		crispStartBtn.setText("crisp start");
		crispStartBtn.addMouseListener(new java.awt.event.MouseAdapter() {
			public void mouseClicked(java.awt.event.MouseEvent evt) {
				crispStartBtnMouseClicked(evt);
			}
		});
		crispStartBtn.setEnabled(false);

		stopButton.setText("stop");
		stopButton.addMouseListener(new java.awt.event.MouseAdapter() {
			public void mouseClicked(java.awt.event.MouseEvent evt) {
				stopButtonMouseClicked(evt);
			}
		});
		stopButton.setEnabled(false);

		loadBtn.setText("load MT-Box...");
		loadBtn.addMouseListener(new java.awt.event.MouseAdapter() {
			public void mouseClicked(java.awt.event.MouseEvent evt) {
				loadBtnMouseClicked(evt);
			}
		});

		stateFindBtn.setText("choose CurrentState file...");
		stateFindBtn.addMouseListener(new java.awt.event.MouseAdapter() {
			public void mouseClicked(java.awt.event.MouseEvent evt) {
				stateFindBtnMouseClicked(evt);
			}
		});
		stateFindBtn.setEnabled(false);

		jLabel3.setFont(new Font("Tahoma", 0, 18));
		jLabel3.setForeground(new java.awt.Color(255, 51, 51));
		jLabel3.setText("FUZZY LOGIC EVALUATOR");

		jTextArea3.setColumns(16);
		jTextArea3.setRows(5);
		jTextArea3.setFont(new Font("Tahoma", 0, 15));
		jScrollPane3.setViewportView(jTextArea3);

		jLabel4.setText("QUERY");
		jLabel5.setText("EVALUATION: ");        


		GroupLayout jPanel1Layout = new GroupLayout(jPanel1);
		jPanel1.setLayout(jPanel1Layout);
		jPanel1Layout.setHorizontalGroup(
				jPanel1Layout.createParallelGroup(GroupLayout.Alignment.LEADING)
				.addGroup(jPanel1Layout.createSequentialGroup()            		
						.addGap(5, 20, 20)
						.addGroup(jPanel1Layout.createParallelGroup(GroupLayout.Alignment.TRAILING)                		
								.addComponent(jLabel1)
								.addComponent(jLabel4)
								.addComponent(jLabel2)
								.addComponent(jLabel5))
								.addGap(5, 20, 20)
								.addGroup(jPanel1Layout.createParallelGroup(GroupLayout.Alignment.LEADING)                		
										.addComponent(jLabel3,GroupLayout.PREFERRED_SIZE, 380, GroupLayout.PREFERRED_SIZE)
										.addComponent(jScrollPane2,GroupLayout.Alignment.TRAILING,  100, 800, Short.MAX_VALUE)
										.addComponent(jScrollPane1,  100, 800, Short.MAX_VALUE)
										.addGroup(jPanel1Layout.createSequentialGroup()                 		
												.addComponent(loadBtn)                		
												.addGap(4,50,50)
												.addComponent(stateFindBtn)
												.addGap(4,50,50)
												.addComponent(startButton)
												.addGap(4,50,50)
												.addComponent(crispStartBtn)
												.addGap(4,50,50)
												.addComponent(stopButton))
												.addComponent(jScrollPane3, 100, 800, Short.MAX_VALUE))
												.addContainerGap())
		);

		jPanel1Layout.setVerticalGroup(
				jPanel1Layout.createParallelGroup(GroupLayout.Alignment.LEADING)
				.addGroup(jPanel1Layout.createSequentialGroup()
						.addContainerGap()
						.addComponent(jLabel3)
						.addGap(2, 6, 6)
						.addGroup(jPanel1Layout.createParallelGroup(GroupLayout.Alignment.LEADING)
								.addComponent(jScrollPane1, 50, 173, GroupLayout.PREFERRED_SIZE)
								.addComponent(jLabel1))	
								.addPreferredGap(LayoutStyle.ComponentPlacement.RELATED)
								.addGroup(jPanel1Layout.createParallelGroup(GroupLayout.Alignment.LEADING)	
										.addComponent(jLabel2)
										.addComponent(jScrollPane2, 50, 173, GroupLayout.PREFERRED_SIZE))
										.addGap(10, 56, 56)
										.addGroup(jPanel1Layout.createParallelGroup(GroupLayout.Alignment.LEADING)
												.addGroup(jPanel1Layout.createSequentialGroup()
														.addComponent(jScrollPane3, 50, 173, GroupLayout.PREFERRED_SIZE)
														.addPreferredGap(LayoutStyle.ComponentPlacement.RELATED,20, Short.MAX_VALUE)
														.addGroup(jPanel1Layout.createParallelGroup(GroupLayout.Alignment.BASELINE) 
																.addComponent(loadBtn)
																.addComponent(stateFindBtn)
																.addComponent(stopButton)
																.addComponent(startButton)
																.addComponent(crispStartBtn))                    
																.addGap(10, 26, 26))
																.addGroup(jPanel1Layout.createSequentialGroup()
																		.addComponent(jLabel4)	
																		.addPreferredGap(LayoutStyle.ComponentPlacement.RELATED)
																		.addComponent(jLabel5)                     
																		.addGap(10, 32, 32))))
		);         		                     

		GroupLayout layout = new GroupLayout(getContentPane());
		getContentPane().setLayout(layout);
		layout.setHorizontalGroup(
				layout.createParallelGroup(GroupLayout.Alignment.LEADING)
				.addComponent(jPanel1,GroupLayout.Alignment.TRAILING,  GroupLayout.DEFAULT_SIZE, GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
		);
		layout.setVerticalGroup(
				layout.createParallelGroup(GroupLayout.Alignment.LEADING)
				.addComponent(jPanel1,GroupLayout.Alignment.TRAILING,  GroupLayout.DEFAULT_SIZE, GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
		);
		pack();
	}

	/**
	 * The action after mouse click on stop button
	 * @param evt the MouseEvent
	 */
	private void stopButtonMouseClicked(java.awt.event.MouseEvent evt) {
		this.monitor.stop();
		startButton.setEnabled(true);
		if (this.monitor.isSubs())
			crispStartBtn.setEnabled(true);
		else
			crispStartBtn.setEnabled(false);
		stopButton.setEnabled(false); 
		stateFindBtn.setEnabled(true);
		loadBtn.setEnabled(true);
	}

	/**
	 * The action after mouse click on start button
	 * @param evt the MouseEvent
	 */
	private void startButtonMouseClicked(java.awt.event.MouseEvent evt) {
		if(monitor.getStateFile()==null)
			javax.swing.JOptionPane.showMessageDialog(null ," choose Current State File, first! ","WARNING",javax.swing.JOptionPane.ERROR_MESSAGE);
		else{
			this.monitor.setFuzzy(true);
			this.monitor.start();
			startButton.setEnabled(false);
			crispStartBtn.setEnabled(false);
			stopButton.setEnabled(true);
			stateFindBtn.setEnabled(false);
			loadBtn.setEnabled(false);
		}
	}

	/**
	 * The action after mouse click on crisp start button
	 * @param evt the MouseEvent
	 */
	private void crispStartBtnMouseClicked(java.awt.event.MouseEvent evt) {
		if(monitor.getStateFile()==null)
			javax.swing.JOptionPane.showMessageDialog(null ," choose Current State File, first! ","WARNING",javax.swing.JOptionPane.ERROR_MESSAGE);
		else{
			this.monitor.setFuzzy(false);
			this.monitor.start();
			startButton.setEnabled(false);
			crispStartBtn.setEnabled(false);
			stopButton.setEnabled(true);
			stateFindBtn.setEnabled(false);
			loadBtn.setEnabled(false);
		}
	}

	/**
	 * The action after mouse click on load button
	 * @param evt the MouseEvent
	 */
	private void loadBtnMouseClicked(java.awt.event.MouseEvent evt){
		JFileChooser c = new JFileChooser(".");
		javax.swing.filechooser.FileFilter filter = new XmlFileFilter();
		c.setFileFilter(filter);	
		c.setSelectedFile(loadFile);
		c.setDialogTitle("Load MT-Box File");
		java.awt.Point p = this.getLocation();
		p.translate(150,150);
		c.setLocation(p);
		int rVal = c.showOpenDialog(this);
		if(rVal == javax.swing.JFileChooser.APPROVE_OPTION) {
			try {
				loadFile = c.getSelectedFile();
				monitor.loadMTBox(loadFile);
			} catch (FileNotFoundException e) {			
				e.printStackTrace();
			} catch (JAXBException e) {			
				e.printStackTrace();
			}		
			monitor.printMTBox();
			stateFindBtn.setEnabled(true);
		}
		if(rVal == javax.swing.JFileChooser.CANCEL_OPTION) {
//			nothing
		}            
	}    

	/**
	 * The action after mouse click on current state button
	 * @param evt the MouseEvent
	 */
	private void stateFindBtnMouseClicked(java.awt.event.MouseEvent evt){
		JFileChooser c = new JFileChooser(".");
		javax.swing.filechooser.FileFilter filter = new XmlFileFilter();
		c.setFileFilter(filter);	
		c.setSelectedFile(stateFile);
		c.setDialogTitle("Find Current State File");
		java.awt.Point p = this.getLocation();
		p.translate(150,150);
		c.setLocation(p);
		int rVal = c.showOpenDialog(this);
		if(rVal == javax.swing.JFileChooser.APPROVE_OPTION) {    	  
			stateFile = c.getSelectedFile();
			monitor.setStateFile(stateFile);
			startButton.setEnabled(true); 
			if (this.monitor.isSubs())
				crispStartBtn.setEnabled(true);
			else
				crispStartBtn.setEnabled(false);
		}
		if(rVal == javax.swing.JFileChooser.CANCEL_OPTION) {
//			nothing
		}           
	}

	/**
	 * Sets String text on current state jTextArea
	 * @param s the text
	 */
	public void setText2(String s){
		jTextArea2.setText(s);
		jTextArea2.repaint();
	}
//	/**
//	* @param args the command line arguments
//	*/
//	public static void main(String args[]) {
//	java.awt.EventQueue.invokeLater(new Runnable() {
//	public void run() {
//	new MonitorJFrame().setVisible(true);
//	}
//	});
//	}
	/**
	 * Sets String text on MTBox jTextArea
	 * @param s the text
	 */
	public void setText1(String s) {
		jTextArea1.setText(s);
		jTextArea1.repaint();

	}
	/**
	 * Sets String text on evaluation jTextArea
	 * @param s the text
	 */
	public void setEvalText(String s) {
		jTextArea3.setText(s);
		jTextArea3.repaint();

	}
}
