/**
 * Temporal Quantified fuzzy DL's
 */


package editor;


import java.awt.Color;

import javax.swing.ButtonGroup;
import javax.swing.GroupLayout;
import javax.swing.JButton;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JOptionPane;
import javax.swing.JPanel;
import javax.swing.JTextField;
import javax.swing.JDialog;
import javax.swing.LayoutStyle;
import javax.swing.SwingConstants;
import javax.swing.border.BevelBorder;

import reasoner.ConcreteConcept;


/**
 * A javax.swing.JDialog for Concept editing
 *
 * @version 1.0 10/12/07
 * @author  marco furlan
 */
public class ConceptDialog extends JDialog {
        private EditorFrame ef;
       
   
    /**
     * Creates new ConceptDialog
     * @param parent the JFrame parent
     * @param title the title
     * @param modal specifies whether dialog blocks user input to other top-level windows 
     * when shown. If true, the modality type property is set to DEFAULT_MODALITY_TYPE 
     * otherwise the dialog is modeless
     *
     */
     public ConceptDialog(JFrame parent, String title, boolean modal) {
            super(parent, title, modal);
            this.ef = (EditorFrame)parent;        
            initComponents();
            
        }
 
     /**
     * Initializes components
     */
    private void initComponents() {
        ButtonGroup buttonGroup1;
        JLabel jLabel10;
        JLabel jLabel5;
        JLabel jLabel6;
        JLabel jLabel7;
        JLabel jLabel8;
        JLabel jLabel9;

        buttonGroup1 = new ButtonGroup();
        jPanel1 = new JPanel();
        jLabel1 = new JLabel();
        jLabel2 = new JLabel();
        okButton = new JButton();
        jLabel3 = new JLabel();
        jTextField1 = new JTextField();
        jLabel5 = new JLabel();
        jTextField2 = new JTextField();
        jLabel6 = new JLabel();
        jLabel7 = new JLabel();
        jTextField3 = new JTextField();
        jTextField4 = new JTextField();
        jLabel8 = new JLabel();
        jTextField5 = new JTextField();
        jLabel9 = new JLabel();
        jTextField6 = new JTextField();
        jLabel10 = new JLabel();
        jLabel11 = new JLabel();
        createButton = new JButton();
        resetButton = new JButton();
        cancelButton = new JButton();
        jLabel13 = new JLabel();

        addWindowListener(new java.awt.event.WindowAdapter() {
            public void windowClosing(java.awt.event.WindowEvent evt) {
                closeDialog(evt);
            }
        });

        jPanel1.setBackground(new java.awt.Color(219, 229, 241));
//        jPanel1.setBorder(javax.swing.BorderFactory.createMatteBorder(2, 2, 2, 2, new java.awt.Color(51, 255, 51)));
        jPanel1.setBorder(javax.swing.BorderFactory.createBevelBorder(BevelBorder.RAISED, new java.awt.Color(51, 255, 51), Color.darkGray));
		 
        jLabel1.setFont(new java.awt.Font("Tahoma", 0, 18));
        jLabel1.setForeground(new java.awt.Color(0, 153, 0));
        jLabel1.setHorizontalAlignment(SwingConstants.CENTER);
        jLabel1.setText("CONCEPT EDITOR");
        jLabel1.setHorizontalTextPosition(SwingConstants.CENTER);

        jLabel2.setLabelFor(jTextField1);
        jLabel2.setText("Concept Name: ");

        okButton.setText("OK");
        okButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                okButtonActionPerformed(evt);
            }
        });

        jLabel3.setFont(new java.awt.Font("Tahoma", 0, 18));
        jLabel3.setForeground(new java.awt.Color(255, 51, 51));
        jLabel3.setHorizontalAlignment(SwingConstants.LEFT);
        jLabel3.setText("CONCEPT AS A Trapezium(a,b,c,d), WHERE y(a) = y(d) = 0.0,  y(b) = y(c) = 1.0 ");

        jTextField1.setText("All");

        jLabel5.setText("maxXVal: ");

        jTextField2.setText("250");
        jTextField2.setInputVerifier(new ConceptVerifier(this));

        jLabel6.setText("Set Points: ");

        jLabel7.setText("x(a) = ");

        jTextField3.setText("96.0");
        jTextField3.setInputVerifier(new ConceptVerifier(this));

        jTextField4.setText("98.0");
        jTextField4.setInputVerifier(new ConceptVerifier(this));

        jLabel8.setText("x(b) = ");

        jTextField5.setText("104.0");
        jTextField5.setInputVerifier(new ConceptVerifier(this));

        jLabel9.setText("x(c) = ");

        jTextField6.setText("106.0");
        jTextField6.setInputVerifier(new ConceptVerifier(this));

        jLabel10.setText("x(d) = ");

        jLabel11.setText("All                            ");

        createButton.setText("Create Concept");
        createButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                createButtonActionPerformed(evt);
            }
        });

        resetButton.setText("Reset");
        resetButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                resetButtonActionPerformed(evt);
            }
        });

        cancelButton.setText("Cancel");
        cancelButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                cancelButtonActionPerformed(evt);
            }
        });

        jLabel13.setFont(new java.awt.Font("Tahoma", 0, 18));
        jLabel13.setForeground(new java.awt.Color(255, 51, 51));
        jLabel13.setHorizontalAlignment(SwingConstants.LEFT);
        jLabel13.setText("AND  x(a), x(b), x(c), x(d) <= maxVal");

        GroupLayout jPanel1Layout = new GroupLayout(jPanel1);
        jPanel1.setLayout(jPanel1Layout);
        jPanel1Layout.setHorizontalGroup(
            jPanel1Layout.createParallelGroup(GroupLayout.Alignment.LEADING)
            .addGroup(jPanel1Layout.createSequentialGroup()
                .addGroup(jPanel1Layout.createParallelGroup(GroupLayout.Alignment.LEADING)
                    .addGroup(jPanel1Layout.createSequentialGroup()
                        .addGap(238, 238, 238)
                        .addComponent(jLabel1))
                    .addGroup(jPanel1Layout.createSequentialGroup()
                        .addGap(39, 39, 39)
                        .addGroup(jPanel1Layout.createParallelGroup(GroupLayout.Alignment.LEADING)
                            .addGroup(jPanel1Layout.createSequentialGroup()
                                .addGap(317, 317, 317)
                                .addComponent(jLabel5)
                                .addGap(37, 37, 37)
                                .addComponent(jTextField2, GroupLayout.PREFERRED_SIZE, 34, GroupLayout.PREFERRED_SIZE))
                            .addGroup(jPanel1Layout.createParallelGroup(GroupLayout.Alignment.TRAILING)
                                .addGroup(jPanel1Layout.createParallelGroup(GroupLayout.Alignment.LEADING)
                                    .addGroup(jPanel1Layout.createSequentialGroup()
                                        .addComponent(jLabel2)
                                        .addPreferredGap(LayoutStyle.ComponentPlacement.RELATED)
                                        .addComponent(jTextField1, GroupLayout.PREFERRED_SIZE, 135, GroupLayout.PREFERRED_SIZE))
                                    .addGroup(jPanel1Layout.createSequentialGroup()
                                        .addComponent(jLabel6)
                                        .addGap(32, 32, 32)
                                        .addGroup(jPanel1Layout.createParallelGroup(GroupLayout.Alignment.LEADING)
                                            .addComponent(jLabel11)
                                            .addGroup(jPanel1Layout.createSequentialGroup()
                                                .addComponent(jLabel7)
                                                .addPreferredGap(LayoutStyle.ComponentPlacement.RELATED)
                                                .addGroup(jPanel1Layout.createParallelGroup(GroupLayout.Alignment.LEADING)
                                                    .addGroup(jPanel1Layout.createSequentialGroup()
                                                        .addGap(51, 51, 51)
                                                        .addComponent(jLabel8))
                                                    .addComponent(jTextField3, GroupLayout.PREFERRED_SIZE, GroupLayout.DEFAULT_SIZE, GroupLayout.PREFERRED_SIZE))
                                                .addPreferredGap(LayoutStyle.ComponentPlacement.RELATED)
                                                .addComponent(jTextField4, GroupLayout.PREFERRED_SIZE, GroupLayout.DEFAULT_SIZE, GroupLayout.PREFERRED_SIZE)
                                                .addGap(16, 16, 16)
                                                .addComponent(jLabel9)
                                                .addPreferredGap(LayoutStyle.ComponentPlacement.RELATED)
                                                .addComponent(jTextField5, GroupLayout.PREFERRED_SIZE, GroupLayout.DEFAULT_SIZE, GroupLayout.PREFERRED_SIZE)
                                                .addGap(29, 29, 29)
                                                .addComponent(jLabel10)
                                                .addPreferredGap(LayoutStyle.ComponentPlacement.RELATED)
                                                .addComponent(jTextField6, GroupLayout.PREFERRED_SIZE, GroupLayout.DEFAULT_SIZE, GroupLayout.PREFERRED_SIZE))))
                                    .addGroup(jPanel1Layout.createSequentialGroup()
                                        .addComponent(okButton)
                                        .addGap(64, 64, 64)
                                        .addComponent(createButton)
                                        .addGap(320, 320, 320)
                                        .addComponent(resetButton)
                                        .addGap(85, 85, 85)
                                        .addComponent(cancelButton)))
                                .addComponent(jLabel13)
                                .addComponent(jLabel3)))))
                .addContainerGap(96, Short.MAX_VALUE))
        );

        jPanel1Layout.linkSize(0, new java.awt.Component[] {jLabel10, jLabel7, jLabel8, jLabel9, jTextField3, jTextField4, jTextField5, jTextField6});

        jPanel1Layout.setVerticalGroup(
            jPanel1Layout.createParallelGroup(GroupLayout.Alignment.LEADING)
            .addGroup(jPanel1Layout.createSequentialGroup()
                .addGap(29, 29, 29)
                .addComponent(jLabel1, GroupLayout.PREFERRED_SIZE, 26, GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(jLabel3, GroupLayout.PREFERRED_SIZE, 26, GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(jLabel13, GroupLayout.PREFERRED_SIZE, 26, GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(LayoutStyle.ComponentPlacement.RELATED, GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                .addGroup(jPanel1Layout.createParallelGroup(GroupLayout.Alignment.BASELINE)
                    .addComponent(jLabel5)
                    .addComponent(jTextField2, GroupLayout.PREFERRED_SIZE, GroupLayout.DEFAULT_SIZE, GroupLayout.PREFERRED_SIZE))
                .addGap(64, 64, 64)
                .addGroup(jPanel1Layout.createParallelGroup(GroupLayout.Alignment.BASELINE)
                    .addComponent(jLabel2)
                    .addComponent(jTextField1, GroupLayout.PREFERRED_SIZE, GroupLayout.DEFAULT_SIZE, GroupLayout.PREFERRED_SIZE))
                .addGap(47, 47, 47)
                .addGroup(jPanel1Layout.createParallelGroup(GroupLayout.Alignment.BASELINE)
                    .addComponent(jLabel6)
                    .addComponent(jLabel7)
                    .addComponent(jTextField3, GroupLayout.PREFERRED_SIZE, GroupLayout.DEFAULT_SIZE, GroupLayout.PREFERRED_SIZE)
                    .addComponent(jLabel9)
                    .addComponent(jTextField5, GroupLayout.PREFERRED_SIZE, GroupLayout.DEFAULT_SIZE, GroupLayout.PREFERRED_SIZE)
                    .addComponent(jLabel10)
                    .addComponent(jTextField6, GroupLayout.PREFERRED_SIZE, GroupLayout.DEFAULT_SIZE, GroupLayout.PREFERRED_SIZE)
                    .addComponent(jLabel8)
                    .addComponent(jTextField4, GroupLayout.PREFERRED_SIZE, GroupLayout.DEFAULT_SIZE, GroupLayout.PREFERRED_SIZE))
                .addGroup(jPanel1Layout.createParallelGroup(GroupLayout.Alignment.LEADING)
                    .addGroup(jPanel1Layout.createSequentialGroup()
                        .addGap(27, 27, 27)
                        .addComponent(jLabel11)
                        .addGap(47, 47, 47)
                        .addGroup(jPanel1Layout.createParallelGroup(GroupLayout.Alignment.BASELINE)
                            .addComponent(okButton)
                            .addComponent(createButton)))
                    .addGroup(jPanel1Layout.createSequentialGroup()
                        .addGap(81, 81, 81)
                        .addGroup(jPanel1Layout.createParallelGroup(GroupLayout.Alignment.BASELINE)
                            .addComponent(cancelButton)
                            .addComponent(resetButton))))
                .addGap(79, 79, 79))
        );
        getContentPane().add(jPanel1, java.awt.BorderLayout.CENTER);

        pack();
    }

    /**
     * Invoked when an action is performed on cancelBtn
     * @param evt the event
     */
    private void cancelButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_cancelButtonActionPerformed
        closeDialog();
    }
    
    /**
     * Closes this ConceptDialog
     */
    private void closeDialog(){
        setVisible(false);
        ef.showKb();
        dispose();
    }
    
    /**
     * Invoked when an action is performed on resetBtn
     * @param evt the event
     */
    private void resetButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_resetButtonActionPerformed
        jTextField3.setText("0.0"); 
        jTextField4.setText("0.0"); 
        jTextField5.setText("0.0");
        jTextField6.setText("0.0");
        jTextField2.setText("1.0");                
    }

    /**
     * Invoked when an action is performed on okBtn
     * @param evt the event
     */
    private void okButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_okButtonActionPerformed
        closeDialog();
    }

    /**
     * Invoked when an action is performed on createBtn
     * @param evt the event
     */
    private void createButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_createButtonActionPerformed
        double a=Double.valueOf(jTextField3.getText()), 
               b=Double.valueOf(jTextField4.getText()), 
               c=Double.valueOf(jTextField5.getText()),
                d=Double.valueOf(jTextField6.getText()),
                m=Double.valueOf(jTextField2.getText());
        if(a<=b && b<=c && c<=d && d<= m){
            String name = jTextField1.getText();
        ConcreteConcept q = new ConcreteConcept(name, a,b,c,d,m,ef.getKb());       
        jLabel11.setText(q.getMeaning());
        ef.getConcCB().addItem(q.getName());
            ef.getConcCB().setSelectedItem(q.getName());
        }else{
           JOptionPane.showMessageDialog(null ," x(a) <= x(b) <= x(c) <= x(d) <= maxVal, please! ","WARNING",JOptionPane.ERROR_MESSAGE);
        }        
    }   
    
    /**
     * Closes this ConceptDialog
     * @param evt the event
     */
    private void closeDialog(java.awt.event.WindowEvent evt) {//GEN-FIRST:event_closeDialog
        setVisible(false);
        ef.showKb();
        dispose();
    }
    
    /**
     * the main method
     * @param args the command line arguments
     */
    public static void main(String args[]) {
        java.awt.EventQueue.invokeLater(new Runnable() {
            public void run() {
                String title = "Concept Editor";                
                new ConceptDialog(new EditorFrame(), title, true).setVisible(true);                
            }
        });
    }    
    
    // Variables declaration 
    protected JButton cancelButton;
    protected JButton createButton;
    protected JLabel jLabel1;
    protected JLabel jLabel11;
    protected JLabel jLabel13;
    protected JLabel jLabel2;
    protected JLabel jLabel3;
    private JPanel jPanel1;
    protected JTextField jTextField1;
    protected JTextField jTextField2;
    protected JTextField jTextField3;
    protected JTextField jTextField4;
    protected JTextField jTextField5;
    protected JTextField jTextField6;
    protected JButton okButton;
    protected JButton resetButton;
   
    
}
