/**
 * Temporal Quantified fuzzy DL's
 */

package editor;

import java.awt.Color;
import java.util.Vector;
import java.io.File;
import java.io.IOException;
import java.io.BufferedReader;
import java.io.StringReader;
import java.io.FileNotFoundException;

import javax.swing.DefaultComboBoxModel;
import javax.swing.GroupLayout;
import javax.swing.JButton;
import javax.swing.JComboBox;
import javax.swing.JFileChooser;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JList;
import javax.swing.JMenuItem;
import javax.swing.JPopupMenu;
import javax.swing.JScrollPane;
import javax.swing.JSeparator;
import javax.swing.LayoutStyle;
import javax.swing.SwingConstants;
import javax.swing.WindowConstants;
import javax.swing.border.BevelBorder;
import javax.swing.filechooser.FileSystemView;
import javax.xml.bind.JAXBException;

import reasoner.*;
import util.XmlFileFilter;

/**
 * A javax.swing.JFrame for editing MetaBox and TBox for KnowleddgeBases
 *
 * @version 1.0 10/12/07
 * @author  marco furlan
 */
public class EditorFrame extends JFrame {
    
    
    /**
     *  Creates new EditorFrame
     */
    public EditorFrame() {
        initComponents();
    }
    
    /**
     * This method is called from within the constructor to
     * initialize the form.
     */
    private void initComponents() {
        
        JButton newBtn;
        JButton okBtn;
        JButton loadBtn;
        JButton jButton7;
        
        JLabel jLabel2;
        JLabel jLabel3;
        JMenuItem jMenuItem1;
        JMenuItem jMenuItem2;
        JPopupMenu jPopupMenu1;
        JScrollPane jScrollPane1;
        JSeparator jSeparator1;

        jPopupMenu1 = new JPopupMenu();
        jMenuItem1 = new JMenuItem();
        jMenuItem2 = new JMenuItem();
        roleComboBox = new JComboBox();
        jLabel1 = new JLabel();
        jButton1 = new JButton();
        jLabel2 = new JLabel();
        jLabel3 = new JLabel();
        quantComboBox = new JComboBox();
        jLabel4 = new JLabel();
        qtfrBtn = new JButton();
        jLabel6 = new JLabel();
        roleBtn = new JButton();
        jButton4 = new JButton();
        conceptComboBox = new JComboBox();
        concBtn = new JButton();
        jLabel7 = new JLabel();
        jButton6 = new JButton();
        jButton7 = new JButton();
        exportBtn = new JButton();
        okBtn = new JButton();
        jScrollPane1 = new JScrollPane();
        listVector = new Vector<String> ();

        jList1 = new JList(listVector);
        newBtn = new JButton();
        loadBtn = new JButton();
        jSeparator1 = new JSeparator();
        resetBtn = new JButton();
        jButton14 = new JButton();
        jLabel9 = new JLabel();
        qryBtn = new JButton();
        jLabel10 = new JLabel();
        jLabel11 = new JLabel();
        jLabel5 = new JLabel();
        jLabel8 = new JLabel();

        jMenuItem1.setText("pray-predator");
        jPopupMenu1.add(jMenuItem1);

        jMenuItem2.setText("localityTemperature");
        jPopupMenu1.add(jMenuItem2);

        setDefaultCloseOperation(WindowConstants.DISPOSE_ON_CLOSE);
        setTitle("Knowledge Base Editor");
        
        roleComboBox.setModel(new DefaultComboBoxModel(new String[] { "distance", "hasTemperature", "hasPressure", "..." }));
        roleComboBox.setEnabled(false);
        roleComboBox.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                roleComboBoxActionPerformed(evt);
            }
        });

        jLabel1.setText("Role: ");
        jLabel1.setEnabled(false);

        jButton1.setText("new...");
        jButton1.setEnabled(false);
        jButton1.addActionListener(new java.awt.event.ActionListener(){
        	public void actionPerformed (java.awt.event.ActionEvent evt) {
                jButton1ActionPerformed(evt);
            }
        });

        jLabel2.setForeground(new java.awt.Color(255, 51, 51));
        jLabel2.setText("MT - Box: ");

        jLabel3.setFont(new java.awt.Font("Tahoma", 0, 18));
        jLabel3.setForeground(new java.awt.Color(255, 51, 0));
        jLabel3.setHorizontalAlignment(SwingConstants.CENTER);
        jLabel3.setText("KNOWLEDGE BASE EDITOR: MetaT-BOX");

        quantComboBox.setModel(new DefaultComboBoxModel(new String[] { "Most", "All", "..." }));
        quantComboBox.setEnabled(false);
        quantComboBox.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                quantComboBoxActionPerformed(evt);               
            }
        });

        jLabel4.setText("Quantifier: ");
        jLabel4.setEnabled(false);

        qtfrBtn.setText("edit...");
        qtfrBtn.setEnabled(false);
        qtfrBtn.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                qtfrBtnActionPerformed(evt);
            }
        });

//        jLabel6.setText("jLabel6");
        jLabel6.setEnabled(false);
        jLabel6.setText(quantComboBox.getSelectedItem().toString());

        roleBtn.setText("Add");
        roleBtn.setEnabled(false);
        roleBtn.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                roleBtnActionPerformed(evt);
            }
        });

        jButton4.setText("Add");
        jButton4.setEnabled(false);

        conceptComboBox.setModel(new DefaultComboBoxModel(new String[] { "D", "A", "..." }));
        conceptComboBox.setEnabled(false);
        conceptComboBox.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                conceptComboBoxActionPerformed(evt);
            }
        });

        concBtn.setText("edit...");
        concBtn.setEnabled(false);
        concBtn.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                concBtnActionPerformed(evt);
            }
        });

        jLabel7.setText("Concept:");
        jLabel7.setEnabled(false);

        jButton6.setText("Add");
        jButton6.setEnabled(false);

        jButton7.setText("EXIT");
        jButton7.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                cancelActionPerformed(evt);
            }
        });

        exportBtn.setText("EXPORT MT-Box");
        exportBtn.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                exportBtnActionPerformed(evt);
            }
        });
        exportBtn.setEnabled(false);

        okBtn.setText("OK");

        jList1.setEnabled(false);
        jScrollPane1.setViewportView(jList1);

        newBtn.setText("NEW MT-Box");
        newBtn.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                newBtnActionPerformed(evt);
            }
        });

        loadBtn.setText("LOAD MT-Box ...");

        resetBtn.setText("RESET MT-Box");
        resetBtn.setEnabled(false);
        resetBtn.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                resetBtnActionPerformed(evt);
            }
        });

        jButton14.setText("Add");
        jButton14.setEnabled(false);

        jLabel9.setText("...");
        jLabel9.setEnabled(false);
        

        qryBtn.setText("edit...");
        qryBtn.setEnabled(false);
        qryBtn.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                qryBtnActionPerformed(evt);
            }
        });

        jLabel10.setText("Query:");
        jLabel10.setEnabled(false);

        jLabel11.setText("Query:    ");
        jLabel11.setEnabled(false);

        jLabel5.setText("jLabel5");
        jLabel5.setEnabled(false);
        jLabel5.setText(roleComboBox.getSelectedItem().toString());

        jLabel8.setText("jLabel8");
        jLabel8.setEnabled(false);
        jLabel8.setText(conceptComboBox.getSelectedItem().toString());

        GroupLayout layout = new GroupLayout(getContentPane());
        getContentPane().setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(GroupLayout.Alignment.LEADING)
            .addGroup(GroupLayout.Alignment.TRAILING, layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(layout.createParallelGroup(GroupLayout.Alignment.LEADING)
                    .addComponent(jLabel10)
                    .addComponent(jLabel7)
                    .addComponent(jLabel4)
                    .addComponent(jLabel1))
                .addGap(84, 84, 84)
                .addGroup(layout.createParallelGroup(GroupLayout.Alignment.LEADING)
                    .addGroup(layout.createParallelGroup(GroupLayout.Alignment.TRAILING)
                        .addComponent(roleComboBox, GroupLayout.PREFERRED_SIZE, 98, GroupLayout.PREFERRED_SIZE)
                        .addComponent(quantComboBox, GroupLayout.PREFERRED_SIZE, 98, GroupLayout.PREFERRED_SIZE))
                    .addGroup(layout.createParallelGroup(GroupLayout.Alignment.LEADING)
                        .addComponent(jLabel11)
                        .addComponent(conceptComboBox, 0, 98, Short.MAX_VALUE)))
                .addGap(22, 22, 22)
                .addGroup(layout.createParallelGroup(GroupLayout.Alignment.LEADING)
                    .addGroup(layout.createSequentialGroup()
                        .addComponent(qryBtn)
                        .addPreferredGap(LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(jLabel9))
                    .addGroup(layout.createSequentialGroup()
                        .addComponent(concBtn)
                        .addPreferredGap(LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(jLabel8, GroupLayout.PREFERRED_SIZE, 98, GroupLayout.PREFERRED_SIZE))
                    .addGroup(layout.createSequentialGroup()
                        .addComponent(jButton1)
                        .addPreferredGap(LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(jLabel5, GroupLayout.PREFERRED_SIZE, 98, GroupLayout.PREFERRED_SIZE))
                    .addGroup(layout.createSequentialGroup()
                        .addComponent(qtfrBtn)
                        .addPreferredGap(LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(jLabel6, GroupLayout.PREFERRED_SIZE, 98, GroupLayout.PREFERRED_SIZE)))
                .addGap(85, 85, 85)
                .addGroup(layout.createParallelGroup(GroupLayout.Alignment.TRAILING)
                    .addComponent(roleBtn)
                    .addComponent(jButton4)
                    .addComponent(jButton6)
                    .addComponent(jButton14))
                .addGap(790, 790, 790))
            .addGroup(layout.createSequentialGroup()
                .addGap(12, 12, 12)
                .addComponent(jLabel3, GroupLayout.PREFERRED_SIZE, 501, GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(newBtn)
                .addGap(35, 35, 35)
                .addComponent(loadBtn, GroupLayout.DEFAULT_SIZE, 142, Short.MAX_VALUE)
                .addGap(581, 581, 581))
            .addGroup(layout.createSequentialGroup()
                .addContainerGap()
                .addComponent(jLabel2)
                .addContainerGap(1311, Short.MAX_VALUE))
            .addGroup(GroupLayout.Alignment.TRAILING, layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(layout.createParallelGroup(GroupLayout.Alignment.TRAILING)
                    .addGroup(GroupLayout.Alignment.LEADING, layout.createSequentialGroup()
                        .addGap(105, 105, 105)
                        .addComponent(jSeparator1, GroupLayout.DEFAULT_SIZE, 698, Short.MAX_VALUE))
                    .addGroup(layout.createSequentialGroup()
                        .addGroup(layout.createParallelGroup(GroupLayout.Alignment.TRAILING)
                            .addComponent( jScrollPane1,GroupLayout.Alignment.LEADING, GroupLayout.DEFAULT_SIZE, 773, Short.MAX_VALUE)
                            .addGroup(layout.createSequentialGroup()
                                .addComponent(okBtn)
                                .addGap(37, 37, 37)
                                .addComponent(exportBtn)
                                .addGap(244, 244, 244)
                                .addComponent(resetBtn)
                                .addPreferredGap(LayoutStyle.ComponentPlacement.RELATED, 86, Short.MAX_VALUE)
                                .addComponent(jButton7, GroupLayout.PREFERRED_SIZE, 113, GroupLayout.PREFERRED_SIZE)))
                        .addGap(30, 30, 30)))
                .addGap(568, 568, 568))
        );

        layout.linkSize(0,new java.awt.Component[] {conceptComboBox, quantComboBox, roleComboBox});

        layout.setVerticalGroup(
            layout.createParallelGroup(GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(layout.createParallelGroup(GroupLayout.Alignment.BASELINE)
                    .addComponent(jLabel3, GroupLayout.PREFERRED_SIZE, 31, GroupLayout.PREFERRED_SIZE)
                    .addComponent(newBtn)
                    .addComponent(loadBtn))
                .addGap(27, 27, 27)
                .addComponent(jSeparator1, GroupLayout.PREFERRED_SIZE, 29, GroupLayout.PREFERRED_SIZE)
                .addGap(25, 25, 25)
                .addGroup(layout.createParallelGroup(GroupLayout.Alignment.LEADING)
                    .addGroup(layout.createSequentialGroup()
                        .addGroup(layout.createParallelGroup(GroupLayout.Alignment.BASELINE)
                            .addComponent(jButton1)
                            .addComponent(roleComboBox, GroupLayout.PREFERRED_SIZE, GroupLayout.DEFAULT_SIZE, GroupLayout.PREFERRED_SIZE)
                            .addComponent(jLabel1)
                            .addComponent(jLabel5))
                        .addGap(23, 23, 23)
                        .addGroup(layout.createParallelGroup(GroupLayout.Alignment.BASELINE)
                            .addComponent(quantComboBox, GroupLayout.PREFERRED_SIZE, GroupLayout.DEFAULT_SIZE, GroupLayout.PREFERRED_SIZE)
                            .addComponent(jLabel4)
                            .addComponent(qtfrBtn)
                            .addComponent(jLabel6))
                        .addGap(29, 29, 29)
                        .addGroup(layout.createParallelGroup(GroupLayout.Alignment.BASELINE)
                            .addComponent(concBtn)
                            .addComponent(conceptComboBox, GroupLayout.PREFERRED_SIZE, GroupLayout.DEFAULT_SIZE, GroupLayout.PREFERRED_SIZE)
                            .addComponent(jLabel7)
                            .addComponent(jLabel8))
                        .addGap(29, 29, 29)
                        .addGroup(layout.createParallelGroup(GroupLayout.Alignment.BASELINE)
                            .addComponent(qryBtn)
                            .addComponent(jLabel10)
                            .addComponent(jLabel11)
                            .addComponent(jLabel9)))
                    .addGroup(layout.createSequentialGroup()
                        .addComponent(roleBtn)
                        .addGap(23, 23, 23)
                        .addComponent(jButton4)
                        .addGap(29, 29, 29)
                        .addComponent(jButton6)
                        .addGap(29, 29, 29)
                        .addComponent(jButton14)))
                .addGap(47, 47, 47)
                .addComponent(jLabel2)
                .addPreferredGap(LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(jScrollPane1, GroupLayout.PREFERRED_SIZE, 180, GroupLayout.PREFERRED_SIZE)
                .addGap(14, 14, 14)
                .addGroup(layout.createParallelGroup(GroupLayout.Alignment.BASELINE)
                    .addComponent(exportBtn)
                    .addComponent(okBtn)
                    .addComponent(resetBtn)
                    .addComponent(jButton7, GroupLayout.DEFAULT_SIZE, GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
                .addGap(212, 212, 212))
        );
        pack();
    }

    /**
     * Invoked when an action is performed on cancelBtn
     * @param evt the event
     */
    private void cancelActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_cancelActionPerformed
        closeDialog();
    }
    /**
     * Closes this EditorFrame
     */
    private void closeDialog(){
        setVisible(false);
        dispose();
    }        
    
    /**
     * Invoked when an action is performed on qryBtn
     * @param evt the event
     */
    private void qryBtnActionPerformed(java.awt.event.ActionEvent evt) {
        String title = "Query Editor";
        qryd = new QueryDialog(this, title, true);        
        qryd.setLocation(this.getLocation());
        qryd.setVisible(true);
    }
    
    /**
     * Invoked when an action is performed on exportBtn: exports the
     * current KnowledgeBase in xml format
     * @param evt the event
     */
    private void exportBtnActionPerformed(java.awt.event.ActionEvent evt) {
    	String s = "MTBox.xml";
    	Query qry = this.getKb().getQuery();
    	JFileChooser choose = null;
    	if (qry!=null)
    		s = qry.getMeaning() + ".xml";
    	if (new File("xml_lib").exists())
    		choose = new JFileChooser("xml_lib");
    	else 
    		choose = new JFileChooser(".");
    	javax.swing.filechooser.FileFilter filter = new XmlFileFilter();
		choose.setFileFilter(filter);
		File saveFile = new File(s);
		choose.setSelectedFile(saveFile);
		choose.setDialogTitle("XML Save MTBox");    	
    	java.awt.Point p = this.getLocation();
		p.translate(150,150);
		choose.setLocation(p);
		int rVal = choose.showSaveDialog(this);
		if(rVal == javax.swing.JFileChooser.APPROVE_OPTION) {    	  
			saveFile = choose.getSelectedFile();
			try{
	            getKb().xmlSave(saveFile);
	        }catch (JAXBException je){
	            je.printStackTrace();
	        }catch(FileNotFoundException fe){
	            fe.printStackTrace();
	        }catch(IOException fe){
	            fe.printStackTrace();
	        }			
		}
		if(rVal == javax.swing.JFileChooser.CANCEL_OPTION) {
//			nothing
		}   
        
    }
    
    /**
     * Invoked when an action is performed on resetBtn: resets the kb
     * @param evt the event
     */
    private void resetBtnActionPerformed(java.awt.event.ActionEvent evt) {
        kb.clear();
        showKb();
    }
    
    /**
     * Invoked when an action is performed on concBtn: opens a new
     * ConceptDialog
     * @param evt the event
     */
    private void concBtnActionPerformed(java.awt.event.ActionEvent evt) {
        String title = "Concept Editor";
        cd = new ConceptDialog(this, title, true);        
        cd.jTextField1.setText(conceptComboBox.getSelectedItem().toString());
        cd.setLocation(this.getLocation());
        cd.setVisible(true);
    }
    
    /**
     * Invoked when an action is performed on roleBtn: creates a new Role
     * @param evt the event
     */
    private void roleBtnActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButton3ActionPerformed
        String rolename = roleComboBox.getSelectedItem().toString();
        if (!rolename.equals("...")){
            Role r = new Role(rolename, kb);
            if (rolename.equals("distance"))
                distance = new Distance(getKb());
            showKb();
        }
    }
    
    
    /**
     * Invoked when an action is performed on newBtn for a new KB
     * @param evt the event
     */
    private void newBtnActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButton10ActionPerformed
        setKb(new KnowledgeBase());
        jButton1.setEnabled(true);
        qtfrBtn.setEnabled(true);
        roleBtn.setEnabled(true);
        concBtn.setEnabled(true);       
        resetBtn.setEnabled(true);       
        qryBtn.setEnabled(true);
        jLabel1.setEnabled(true);
        jLabel4.setEnabled(true);
        jLabel5.setEnabled(true);
        jLabel6.setEnabled(true);
        jLabel7.setEnabled(true);
        jLabel8.setEnabled(true);
        jLabel9.setEnabled(true);
        jLabel10.setEnabled(true);
        jLabel11.setEnabled(true);
        roleComboBox.setEnabled(true);
        conceptComboBox.setEnabled(true);
        quantComboBox.setEnabled(true);
        jList1.setEnabled(true);
        exportBtn.setEnabled(true);
    }
    
    /**
     * Invoked when an action is performed on qtfrBtn: opens a new QuantifierDialog
     * @param evt the event
     */
    private void qtfrBtnActionPerformed(java.awt.event.ActionEvent evt) {
        String title = "Quantifier Editor";
        qd = new QuantifierDialog(this, title, true);        
        qd.jTextField1.setText(quantComboBox.getSelectedItem().toString());
        qd.setLocation(this.getLocation());
        qd.setVisible(true);
    }
    
    /**
     * Invoked when an action is performed on conceptComboBox
     * @param evt the event
     */
    private void conceptComboBoxActionPerformed(java.awt.event.ActionEvent evt) {
        String s =((((JComboBox)evt.getSource()).
                getSelectedItem()).toString());
        jLabel8.setText(s);
    }
    
    /**
     * Invoked when an action is performed on quantComboBox
     * @param evt the event
     */
    private void quantComboBoxActionPerformed(java.awt.event.ActionEvent evt) {
        String s =((((JComboBox)evt.getSource()).
                getSelectedItem()).toString());
        jLabel6.setText(s);
    }
    
    /**
     * Invoked when an action is performed on roleComboBox
     * @param evt the event
     */
    private void roleComboBoxActionPerformed(java.awt.event.ActionEvent evt) {
        String s =((((JComboBox)evt.getSource()).
                getSelectedItem()).toString());
        jLabel5.setText(s);
    }
    private void jButton1ActionPerformed(java.awt.event.ActionEvent evt) {                                         
        String role;
        role = javax.swing.JOptionPane.showInputDialog(this, 
                "input the role name, please!", "Role Editor", javax.swing.JOptionPane.PLAIN_MESSAGE);
       if( null!=role && !role.equals("")){
       this.roleComboBox.addItem(role);
       this.roleComboBox.setSelectedItem(role);
       this.jLabel5.setText(role);                       
                }
    }                   
    
    /**
     * @param v the Vector
     */
    public void setListVector(Vector<String> v){
        this.listVector = v;
    }
    /**
     * @return the listVector
     */
    public Vector<String> getListVector(){
        return this.listVector;
    }
    /**
     * Shows the KnowledgeBase
     */
    public void showKb(){
        Vector<String> v = getListVector();
        String s = kb.toString();
        String line;
        BufferedReader in  = new BufferedReader(new StringReader(s));
        v.clear();
        try{
            while (null!=(line = in.readLine())){
                v.add(line);
            }
        }catch (java.io.IOException e){
            e.printStackTrace();
        }
        jList1.setListData(v);
        jList1.repaint();
        
    }
    /**
     * the main method
     * @param args the command line arguments
     */
    public static void main(String args[]) {
        java.awt.EventQueue.invokeLater(new Runnable() {
            public void run() {
                java.awt.Dimension d = java.awt.Toolkit.getDefaultToolkit().getScreenSize();
                EditorFrame ef = new EditorFrame();
                ef.setSize(d.width-200, d.height-100);
                ef.setLocation((d.width - ef.getSize().width) / 4,
                        (d.height - ef.getSize().height) / 8);
                ef.getContentPane().setBackground(new Color(219,229,241));
//                ef.getRootPane().setBorder(javax.swing.BorderFactory.createMatteBorder(2, 2, 2, 2, new java.awt.Color(51, 255, 51)));
                ef.getRootPane().setBorder(javax.swing.BorderFactory.createBevelBorder(BevelBorder.RAISED, new java.awt.Color(51, 255, 51), Color.darkGray));
       		 
                ef.setVisible(true);
            }
        });
    }
    /**
     * @return the kb
     */
    public KnowledgeBase getKb(){
        return this.kb;
    }
    /**
     * sets the kb
     * @param kb the kb to set
     */
    public void setKb(KnowledgeBase kb){
        this.kb=kb;
    }
    /**
     * @return the quantComboBox
     */
    public JComboBox getQuantCB(){
        return this.quantComboBox;
    }
    /**
     * @return the concComboBox
     */
    public JComboBox getConcCB(){
        return this.conceptComboBox;
    }
    /**
     * @return the rolecComboBox
     */
    public JComboBox getRoleCB(){
        return this.roleComboBox;
    }
    // Variables declaration 
    protected JComboBox conceptComboBox;
    private JButton jButton1;
    private JButton resetBtn;
    protected JButton jButton14;
    protected JButton qryBtn;
    private JButton qtfrBtn;
    private JButton roleBtn;
    private JButton jButton4;
    private JButton concBtn;
    private JButton jButton6;
    private JButton exportBtn;
    private JLabel jLabel1;
    protected JLabel jLabel10;
    protected JLabel jLabel11;
    private JLabel jLabel4;
    protected JLabel jLabel5;
    private JLabel jLabel6;
    private JLabel jLabel7;
    protected JLabel jLabel8;
    protected JLabel jLabel9;
    private JList jList1;
    protected JComboBox quantComboBox;
    protected JComboBox roleComboBox;
    
    private KnowledgeBase kb;
    private Vector<String> listVector;
    private QuantifierDialog qd;
    private ConceptDialog cd;
    private QueryDialog qryd;
    private Distance distance;
}




