/**
 * Temporal Quantified fuzzy DL's
 */

package monitorDb;

import java.awt.Color;
import java.awt.Font;
import java.io.File;
import java.io.FileNotFoundException;

import javax.swing.GroupLayout;
import javax.swing.JButton;
import javax.swing.JFileChooser;
import javax.swing.JLabel;
import javax.swing.JTextArea;
import javax.swing.LayoutStyle;
import javax.swing.border.BevelBorder;
import javax.xml.bind.JAXBException;
import util.XmlFileFilter;


/**
 * A JFrame as a Graphical User Interface for Monitor
 * 
 * @version 1.0 10/12/07
 * @author marco furlan
 *
 */
public class MonitorJFrame extends javax.swing.JFrame {
    private Monitor monitor;
    private File loadFile= null;

    /**
     * The ABox button
     */
    JButton aBoxBtn;
    /**
     * The evaluate button
     */
    JButton evaluateBtn;
    /**
     * The MTBox button
     */
    JButton mTBoxBtn;
    JButton crispEvalBtn;
    JButton exitBtn;

    JLabel jLabel1;
    JLabel jLabel2;
    JLabel titleLbl;
    JLabel jLabel4;
    JLabel jLabel5;
    javax.swing.JPanel jPanel1;
    javax.swing.JScrollPane jScrollPane1;
    javax.swing.JScrollPane jScrollPane3;
    /**
     * The MTBox textArea
     */
    JTextArea jTextArea1;
    /**
     * The GraphPanel
     */
    GraphPanel graphp;
    /**
     * The LegendaPanel
     */
    LegendaPanel legenda;
    /**
     * The evaluation textArea
     */
    JTextArea jTextArea3;
    
    
    /**
     * Creates new MonitorJFrame 
     */
    public MonitorJFrame() {
        initComponents();
    }
     /**
     *  Creates new MonitorJFrame
     * @param m the Monitor
     */
    public MonitorJFrame(Monitor m) {        
        initComponents();
        this.monitor = m;                
    }
        
    
    /**
     * Initializes the Components
     */
    private void initComponents() {        

        jPanel1 = new javax.swing.JPanel();
        jScrollPane1 = new javax.swing.JScrollPane();
        jTextArea1 = new JTextArea();
        graphp = new GraphPanel(this);

        legenda = new LegendaPanel();
        jLabel1 = new JLabel();
        jLabel2 = new JLabel();
        aBoxBtn = new JButton();
        evaluateBtn = new JButton();
        crispEvalBtn = new JButton();
        mTBoxBtn = new JButton();
        exitBtn = new JButton();

        titleLbl = new JLabel();
        jScrollPane3 = new javax.swing.JScrollPane();
        jTextArea3 = new JTextArea();
        jLabel4 = new JLabel();
        jLabel5 = new JLabel();

        setDefaultCloseOperation(javax.swing.WindowConstants.DISPOSE_ON_CLOSE);
        setTitle("FUZZY TEMPORAL LOGIC EVALUATION");
//        jPanel1.setBorder(javax.swing.BorderFactory.createMatteBorder(2, 2, 2, 2, new java.awt.Color(51, 255, 51)));
        jPanel1.setBorder(javax.swing.BorderFactory.createBevelBorder(BevelBorder.RAISED, new java.awt.Color(51, 255, 51), Color.darkGray));
    	
        jPanel1.setBackground(new Color(219,229,241));
        jTextArea1.setColumns(20);
        jTextArea1.setRows(5);
        jTextArea1.setFont(new Font("Tahoma", 0, 15));
        jScrollPane1.setViewportView(jTextArea1);
        
        jLabel1.setText("K - Base: ");
        jLabel2.setText("A - Box: ");

        aBoxBtn.setText("load ABox From DB");
        aBoxBtn.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mouseClicked(java.awt.event.MouseEvent evt) {
                aBoxBtnMouseClicked(evt);
            }
        });
        aBoxBtn.setEnabled(false);

        evaluateBtn.setText("evaluate");
        evaluateBtn.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mouseClicked(java.awt.event.MouseEvent evt) {
                evaluateBtnMouseClicked(evt);
            }
        });
        evaluateBtn.setEnabled(false);
        
        crispEvalBtn.setText("crisp evaluate");
        crispEvalBtn.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mouseClicked(java.awt.event.MouseEvent evt) {
            	crispEvalBtnMouseClicked(evt);
            }
        });
        crispEvalBtn.setEnabled(false);        
        
        mTBoxBtn.setText("load MT-Box...");
        mTBoxBtn.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mouseClicked(java.awt.event.MouseEvent evt) {
            	mTBoxBtnMouseClicked(evt);
            }
        });
        
        exitBtn.setText("exit");
        exitBtn.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mouseClicked(java.awt.event.MouseEvent evt) {
            	exitBtnMouseClicked(evt);
            }
        });
        
        titleLbl.setFont(new Font("Tahoma", 0, 18));
        titleLbl.setForeground(new java.awt.Color(255, 51, 51));
        titleLbl.setText("LocalityTemperatures MONITOR");
        
        jTextArea3.setColumns(20);
        jTextArea3.setRows(7);
        jTextArea3.setLineWrap(true);
        jTextArea3.setWrapStyleWord(true);
        jTextArea3.setFont(new Font("Tahoma", 0, 15));
        jScrollPane3.setViewportView(jTextArea3);

        jLabel4.setText("QUERY");
        jLabel5.setText("EVALUATION: ");        

        GroupLayout jPanel1Layout = new GroupLayout(jPanel1);
        jPanel1.setLayout(jPanel1Layout);
        jPanel1Layout.setHorizontalGroup(
            jPanel1Layout.createParallelGroup(GroupLayout.Alignment.LEADING)
            .addGroup(jPanel1Layout.createSequentialGroup()            		
            	.addGap(5, 20, 20)
                .addGroup(jPanel1Layout.createParallelGroup(GroupLayout.Alignment.TRAILING)                		
                	.addComponent(jLabel1)
                	.addComponent(jLabel4)
                	.addComponent(jLabel2)
                	.addComponent(legenda,  50, 90,  GroupLayout.PREFERRED_SIZE)
                	.addComponent(jLabel5))
                .addGap(5, 20, 20)
                .addGroup(jPanel1Layout.createParallelGroup(GroupLayout.Alignment.LEADING)                		
                		.addComponent(titleLbl,GroupLayout.PREFERRED_SIZE, 380, GroupLayout.PREFERRED_SIZE)
                		.addComponent(graphp,GroupLayout.Alignment.TRAILING,  100, 800, Short.MAX_VALUE)
                		.addComponent(jScrollPane1,  100, 800, Short.MAX_VALUE)
                		.addGroup(jPanel1Layout.createSequentialGroup()                 		
                				.addComponent(mTBoxBtn)                		
                				.addGap(4,60,60)    
                				.addComponent(aBoxBtn)
                				.addGap(4,60,60)
                				.addComponent(evaluateBtn)
                				.addGap(4, 60, 60)
                				.addComponent(crispEvalBtn)
                				.addGap(4, 60, 60)
                				.addComponent(exitBtn))
                				.addComponent(jScrollPane3, 100, 800, Short.MAX_VALUE))
                				.addContainerGap())
        );

        jPanel1Layout.setVerticalGroup(
            jPanel1Layout.createParallelGroup(GroupLayout.Alignment.LEADING)
            .addGroup(jPanel1Layout.createSequentialGroup()
            		.addContainerGap()
            		.addComponent(titleLbl)
            		.addGap(2, 6, 6)
            		.addGroup(jPanel1Layout.createParallelGroup(GroupLayout.Alignment.LEADING)
            		.addComponent(jScrollPane1, 50, 173, Short.MAX_VALUE)
            		.addComponent(jLabel1))	
            	.addPreferredGap(LayoutStyle.ComponentPlacement.RELATED)
            	.addGroup(jPanel1Layout.createParallelGroup(GroupLayout.Alignment.LEADING)	
            			.addGroup(jPanel1Layout.createSequentialGroup()
                                .addComponent(jLabel2)
                                .addPreferredGap(LayoutStyle.ComponentPlacement.RELATED)
                                .addComponent(legenda, 110, 200, GroupLayout.PREFERRED_SIZE)                           
                                ) 
            			.addComponent(graphp, 115, 200, 295))            			
            			.addPreferredGap(LayoutStyle.ComponentPlacement.RELATED)
            			.addGroup(jPanel1Layout.createParallelGroup(GroupLayout.Alignment.LEADING)
            			.addGroup(jPanel1Layout.createSequentialGroup()
            			.addComponent(jScrollPane3, 50, 173, Short.MAX_VALUE)
                    	.addPreferredGap(LayoutStyle.ComponentPlacement.RELATED,20, Short.MAX_VALUE)
                    	.addGroup(jPanel1Layout.createParallelGroup(GroupLayout.Alignment.BASELINE) 
                    	.addComponent(mTBoxBtn)                   
                    	.addComponent(evaluateBtn)
                        .addComponent(aBoxBtn)
                        .addComponent(crispEvalBtn)
                        .addComponent(exitBtn))                       
                        .addGap(10, 26, 26))
                        .addGroup(jPanel1Layout.createSequentialGroup()
                        .addComponent(jLabel4)	
                        .addPreferredGap(LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(jLabel5)                      
                        .addGap(10, 32, 32))))
           );        		                     

        GroupLayout layout = new GroupLayout(getContentPane());
        getContentPane().setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(GroupLayout.Alignment.LEADING)
            .addComponent(jPanel1,GroupLayout.Alignment.TRAILING,  GroupLayout.DEFAULT_SIZE, GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(GroupLayout.Alignment.LEADING)
            .addComponent(jPanel1,GroupLayout.Alignment.TRAILING,  GroupLayout.DEFAULT_SIZE, GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
        );

        graphp.setVisible(true);
        legenda.setVisible(true);
        pack();
    }

    /**
     * The action after mouse click on evaluate button
     * @param evt the MouseEvent
     */
    private void evaluateBtnMouseClicked(java.awt.event.MouseEvent evt) {
    	this.getMonitor().evaluate(true);
    	
        aBoxBtn.setEnabled(true);
        evaluateBtn.setEnabled(false); 
        crispEvalBtn.setEnabled(false); 
        mTBoxBtn.setEnabled(true);
    }
    
    
    /**
     * The action after mouse click on crisp evaluate button
     * @param evt the MouseEvent
     */
    private void crispEvalBtnMouseClicked(java.awt.event.MouseEvent evt) {
    	this.getMonitor().evaluate(false);
    	
        aBoxBtn.setEnabled(true);
        evaluateBtn.setEnabled(false); 
        crispEvalBtn.setEnabled(false); 
        mTBoxBtn.setEnabled(true);
    }

    /**
     * The action after mouse click on aBox button
     * @param evt the MouseEvent
     */
    private void aBoxBtnMouseClicked(java.awt.event.MouseEvent evt) {
    	try {
			monitor.setABox();
		} catch (Exception e) {			
			e.printStackTrace();
			return;
		}
		monitor.printMTBox();
    	monitor.showABox();	

    	mTBoxBtn.setEnabled(true);
    	aBoxBtn.setEnabled(true);
        evaluateBtn.setEnabled(true);
        if (monitor.isSubs())
        	crispEvalBtn.setEnabled(true); 
        else
        	crispEvalBtn.setEnabled(false);

   }
    
    /**
     * The action after mouse click on MTBox button
     * @param evt the MouseEvent
     */
    private void mTBoxBtnMouseClicked(java.awt.event.MouseEvent evt){
    	JFileChooser c = null;		
		javax.swing.filechooser.FileFilter filter = new XmlFileFilter();			
		if (new File("xml_lib").exists())
    		c = new JFileChooser("xml_lib");
    	else 
    		c = new JFileChooser(".");
    	c.setFileFilter(filter);	
		c.setSelectedFile(loadFile);
		c.setDialogTitle("Load MT-Box File");
        java.awt.Point p = this.getLocation();
        p.translate(150,150);
        c.setLocation(p);
      int rVal = c.showOpenDialog(this);
      if(rVal == javax.swing.JFileChooser.APPROVE_OPTION) {
    	  try {
    		loadFile = c.getSelectedFile();
			monitor.loadMTBox(loadFile);
		} catch (FileNotFoundException e) {			
			e.printStackTrace();
		} catch (JAXBException e) {			
			e.printStackTrace();
		}		
		monitor.printMTBox();
		
		mTBoxBtn.setEnabled(true);
		aBoxBtn.setEnabled(true);  
		evaluateBtn.setEnabled(false); 
	    crispEvalBtn.setEnabled(false); 
      }
      if(rVal == javax.swing.JFileChooser.CANCEL_OPTION) {
//       nothing
      }         
    }     
  
//	    /**
//	     * @param args the command line arguments
//	     */
//    public static void main(String args[]) {
//        java.awt.EventQueue.invokeLater(new Runnable() {
//            public void run() {
//                new MonitorJFrame().setVisible(true);
//            }
//        });
//    }
    /**
     * The action after mouse click on exitBtn button
     * @param evt the MouseEvent
     */
    private void exitBtnMouseClicked(java.awt.event.MouseEvent evt) {
    	this.setVisible(false);
    	this.dispose();
    }
	/**
	 * Sets String text on MTBox jTextArea
     * @param s the text
	 */
	public void setText1(String s) {
		 jTextArea1.setText(s);
	     jTextArea1.repaint();
		
	}
	/**
	 * Sets String text on evaluation jTextArea
     * @param s the text
	 */
	public void setEvalText(String s) {
		jTextArea3.setText(s);
	     jTextArea3.repaint();
		
	}
	/**
	 * @return the monitor
	 */
	public Monitor getMonitor() {
		return monitor;
	}
	/**
	 * @param monitor the monitor to set
	 */
	public void setMonitor(Monitor monitor) {
		this.monitor = monitor;
	}
	/**
	 * @return the graphp
	 */
	public GraphPanel getGp() {
		return graphp;
	}
	/**
	 * @param graphp the graphp to set
	 */
	public void setGp(GraphPanel graphp) {
		this.graphp = graphp;
	}
	/**
	 * @return the legenda
	 */
	public LegendaPanel getLegenda() {
		return legenda;
	}
	/**
	 * @param legenda the legenda to set
	 */
	public void setLegenda(LegendaPanel legenda) {
		this.legenda = legenda;
	}
	/**
	 * @return the titleLbl
	 */
	public JLabel getTitleLbl() {
		return titleLbl;
	}
	/**
	 * @param titleLbl the titleLbl to set
	 */
	public void setTitleLbl(JLabel titleLbl) {
		this.titleLbl = titleLbl;
	}
}
