/**
 * Temporal Quantified fuzzy DL's
 */
package reasoner;

import java.util.TreeSet;

/**
 * This interface represents the generic fuzzy set.
 * @author marco furlan
 *
 */
public interface FuzzySet {

	/**
	 * Gives Lambda, the alpha level set for membership values
	 * @return Lambda as a TreeSet<Double>
	 */
	TreeSet<Double> getLambda();
//	/**
//	 * @param f
//	 * @return the sum with a FuzzySet
//	 */
//	public FuzzySet sum(FuzzySet f);
//	/**
//	 * @param f
//	 * @return the difference with a FuzzySet
//	 */
//	public FuzzySet diff(FuzzySet f);
//	/**
//	 * @param f
//	 * @return the product with a FuzzySet
//	 */
//	public FuzzySet prod(FuzzySet f);
//	/**
//	 * @param f
//	 * @return the ratio with a FuzzySet
//	 */
//	public FuzzySet ratio(FuzzySet f);
//	/**
//	 * @param f
//	 * @return the intersection with a FuzzySet
//	 */
//	public FuzzySet intersection(FuzzySet f);
//	/**
//	 * @param f
//	 * @return the union of FuzzySets
//	 */
//	public FuzzySet union(FuzzySet f);

	/**
	 * Gives the integer cardinality at the given alpha level.
	 * The String mode operates selection over Individuals.
	 * @param alpha the given alpha level
	 * @param mode the selecting String
	 * @return the cardinality
	 */
	Integer card(Double alpha, String mode);
}
