/**
 * Temporal Quantified fuzzy DL's
 */
package reasoner;

/**
 * This class represents Event Individuals as subclass of DynamicInd
 * @author marco furlan
 *
 */
public class EventInd extends DynamicInd {

	/**
	 * Constructs a new EventInd by name, ULineEvent and Knowledge Base.
	 * It's time is set to the NOW constant
	 * @param name the name
	 * @param line the ULineEvent
	 * @param kb the Knowledge Base
	 */
	public EventInd(String name, ULineEvent line, KnowledgeBase kb) {	
		super(name, line, 0.0, kb);
		setTime(getNOW());
//		getKb().addIndividual(this);
	}

	/**
	 * Constructs a new EventInd by name, ULineEvent, time and Knowledge Base
	 * @param name the name
	 * @param line the ULineEvent
	 * @param time the time
	 * @param kb the Knowledge Base
	 */
	public EventInd(String name, ULineEvent line, double time,
			KnowledgeBase kb) {
		super(name, line, time, kb);
//		setTime(time);
//		setULine(line);		
//		line.add(time, this);
//		getKb().addIndividual(this);
	}
	/**
	 * Evaluates the membership value for this EventInd in the given
	 * Concept
	 * @param c the Concept	
	 * @see reasoner.Individual#degree(reasoner.Concept)
	 */
	public double degree(Concept c){
		System.out.print(c.getName()+"("+this.getName()+"): ");		
		if (c.containsKey(this)){
			System.out.println(c.get(this));
			return c.get(this);
		}
		else{ 
			System.out.println(0.0);
			return 0.0;
		}
	}

}
