/**
 * Temporal Quantified fuzzy DL's
 */
package util;

import java.text.NumberFormat;

/**
 * A geometrical point, with x, y coordinates
 * @author marco furlan
 */
public class Point {
	/**
	 * The x coordinate
	 */
	private Double x;	
	/**
	 * The y coordinate
	 */
	private Double y;
	/**
	 * The String representation
	 */
	private String s="";
	
	
	/**
	 * Constructor for a new Point
	 * @param x1 the x coordinate
	 * @param y1 the y coordinate
	 */
	public Point(Double x1, Double y1){
		setX(x1);
		setY(y1);
	}
	
	/**
	 * @param x the x
	 * @param y the y
	 */
	public void set(Double x, Double y) {		
		this.y = y;
		this.x = x;
	}
	
	/**
	 * @return the s
	 */
	public String getS() {
		return s;
	}


	/**
	 * @param s the s to set
	 */
	public void setS(String s) {
		this.s = s;
	}


	/**
	 * @return the x
	 */
	public Double getX() {
		return x;
	}


	/**
	 * @param x the x to set
	 */
	public void setX(Double x) {
		this.x = x;
	}


	/**
	 * @return the y
	 */
	public Double getY() {
		return y;
	}


	/**
	 * @param y the y to set
	 */
	public void setY(Double y) {
		this.y = y;
	}


	
	
	/**
	 * A String representation for this Point
	 * @return the String
	 */
	public String toString(){
		String s1;
		
		NumberFormat formatter = NumberFormat.getNumberInstance();
		formatter.setMaximumFractionDigits(2);
		if (this.getS().equals("")){
		s1 = formatter.format(this.getY())+"/" + 
			formatter.format(this.getX());
		setS(s1);
		
		}else{
			s1 = formatter.format(this.getY())+"/" + 
			this.getS();
		}
		return s1;
	}

}
