/**
 * Temporal Quantified fuzzy DL's
 */
package prayPredator;


import java.awt.BorderLayout;
import java.awt.Color;
import java.awt.Dimension;
import java.awt.Toolkit;
import java.util.StringTokenizer;

import javax.swing.JButton;
import javax.swing.JFrame;
import javax.swing.JPanel;

/**
 * A JApplet class for simulating a pray-predator system, with current state 
 * in xml format export capability
 * @author marco furlan
 *
 */
public class XmlPrayPredator extends PrayPredator {

	

	//Initialize the applet
    /* (non-Javadoc)
     * @see prayPredator.PrayPredator#init()
     */
    public void init() {
    	
        setLayout(new BorderLayout());

        panel = new XmlGraphPanel(this);
        panel.setVisible(true);
        add("Center", panel);
        controlPanel = new JPanel();
        controlPanel.setBackground(new Color(219,229,241));
        add("South", controlPanel);
        scramble = new JButton("Scramble");
        controlPanel.add(scramble); 
        scramble.addActionListener(this); 

        try {
            edges = this.getParameter("edges", "Pray-One/50,Pray-Two/50,Pray-Three/50");
//        	edges = this.getParameter("edges", "Pray-One/50,Pray-Two/50");
//            edges = this.getParameter("edges", "Pray-One/50");


            for (StringTokenizer t = new StringTokenizer(edges, ","); t.hasMoreTokens(); ) {
                String str = t.nextToken();
                int i = str.indexOf('-');
                if (i > 0) {
                    int len = 100;
                    int j = str.indexOf('/');
                    if (j > 0) {
                        len = Integer.valueOf(str.substring(j + 1)).intValue();
                        str = str.substring(0, j);
                    }
                    panel.addEdge(str.substring(0, i), str.substring(i + 1), len);
                }
            }
        } catch (Exception e) {
                   e.printStackTrace();
        }
        Dimension d = this.getSize();
        try {
            center = this.getParameter("center", "Pray");
        if (center != null){
            Node n = panel.nodes[panel.findNode(center)];
            n.x = d.width /7;
            n.y = d.height/7;
            n.setPray(true);
            n.dirx = +1;
            n.diry = +1;
        }
    } catch (Exception e) {
            e.printStackTrace();
    }
    }
    /**
	 * Main method
	 * @param args the parameter "edge" and "center"
	 */
    public static void main(String[] args) {
        PrayPredator applet = new XmlPrayPredator();
        applet.isStandalone = true;        

        JFrame frame;
        frame = new JFrame();
        frame.setTitle("Pray Predator XmlEmulator");

        frame.add(applet, BorderLayout.CENTER);
      
        Dimension d = Toolkit.getDefaultToolkit().getScreenSize();
		frame.setSize(d.width*4/5, d.height*4/5);
		frame.setLocation((d.width - frame.getSize().width) / 4 *3,
				(d.height - frame.getSize().height) /4 *3);
        applet.init();
        applet.start();
        frame.setDefaultCloseOperation(javax.swing.WindowConstants.EXIT_ON_CLOSE);
        frame.setVisible(true);
    }
}
